/*
 * 	startup.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

/* Reset and Clock Generator */
#define		RCC_APB1ENR 	((volatile unsigned int *)	0x40023840)  
#define		RCC_APB1RSTR 	((volatile unsigned int *)	0x40023820)  


/* Port D */
#define		PORT_D_BASE		0x40020C00
#define		GPIO_D_MODER 	((volatile unsigned int *)	(PORT_D_BASE))  
#define		GPIO_D_OTYPER 	((volatile unsigned short *)(PORT_D_BASE+0x4))  
#define		GPIO_D_OSPEEDR 	((volatile unsigned int *)	(PORT_D_BASE+0x8))  
#define		GPIO_D_PUPDR 	((volatile unsigned int *)	(PORT_D_BASE+0xC))  
#define		GPIO_D_IDRLOW 	((volatile unsigned char *)(PORT_D_BASE+0x10))  
#define		GPIO_D_IDRHIGH 	((volatile unsigned char *)(PORT_D_BASE+0x11))  
#define		GPIO_D_ODRLOW 	((volatile unsigned char *)	(PORT_D_BASE+0x14))  
#define		GPIO_D_ODRHIGH 	((volatile unsigned char *)	(PORT_D_BASE+0x15))  


/* Timer 7 */
#define		TIM7_CR1 	((volatile unsigned short *)	0x40001400)  
#define		TIM7_CR2 	((volatile unsigned short *)	0x40001404) 
#define		TIM7_DIER 	((volatile unsigned short *)	0x4000140C)  
#define		TIM7_SR 	((volatile unsigned short *)	0x40001410)  
#define		TIM7_EGR 	((volatile unsigned short *)	0x40001414) 
#define		TIM7_CNT 	((volatile unsigned short *)	0x40001424)  
#define		TIM7_PSC	((volatile unsigned short *)	0x40001428)  
#define		TIM7_ARR	((volatile unsigned short *)	0x4000142C)  

#define UIF		(1<<0)
#define UIE		(1<<0)
#define UG		(1<<0)
#define ARPE	(1<<7)
#define OPM		(1<<3)
#define URS		(1<<2)
#define UDIS	(1<<1)
#define	CEN		(1<<0)


#define NVIC_TIM7_IRQ_BPOS  (1<<23)
#define	NVIC_TIM7_ISER 		((volatile unsigned int *)	0xE000E104)  
#define	TIM7_IRQVEC 		((void (**)(void) ) 0x2001C11C ) 


volatile char flag;
volatile int ms;

#define SIMULATOR
void timer7_interrupt( void )
{  /* 1 ms period */
	*TIM7_SR &= ~UIF;
#ifndef SIMULATOR
	_outchar( 'F' );
#endif
		flag ^= (flag | 1); /* toggle bit 0 */

	if( ms >= 1000)
	{
		flag ^= (flag | 1); /* toggle bit 0 */
		ms = 0;
#ifndef SIMULATOR
		_outchar( flag+'0' );
#endif
	}else ms++;
}

void timer7_init( )
{
	/* System core clock: 168MHz
	 * TIM6 and TIM7 clocks: 84 MHz
	 * APB2 Clock: 84 MHz
	 * APB1 Clock: 42 MHz */
	
	/* For Now, move to debugger MD407 and simulator init */ 
	*RCC_APB1ENR	|= 0x10; 	/* Enable TIMER 6 */	
	*RCC_APB1RSTR	|= 0x10; 	/* Reset TIMER 6 */	
	*RCC_APB1RSTR	&= ~0x10; 	

	*RCC_APB1ENR	|= 0x20; 	/* Enable TIMER 7 */	
	*RCC_APB1RSTR	|= 0x20; 	/* Reset TIMER 7 */	
	*RCC_APB1RSTR	&= ~0x20; 	

	 *TIM7_CR1 &= ~CEN;
	 	 
	*TIM7_IRQVEC = timer7_interrupt;
	*NVIC_TIM7_ISER |= NVIC_TIM7_IRQ_BPOS;	/* Enable this interrupt */ 
	 
	 /* freq: PSC is # of microsecs-1 */
#ifdef SIMULATOR
	*TIM7_PSC= 999; 
	*TIM7_ARR = 83;
#else
	*TIM7_PSC= 999; 
	*TIM7_ARR = 83;
#endif
	*TIM7_DIER |= UIE;
	//*TIM7_CR1 |= (CEN | OPM);	/* One pulse mode */
	*TIM7_CR1 |= CEN;

}

void timer7_deinit( )
{
	 *TIM7_CR1 &= ~CEN;
}


void gpio_init( void )
{ /* for test */
	*GPIO_D_MODER = 0x00005555;		
	*GPIO_D_PUPDR = 0x00000000;		/* Input, pull down */
    *GPIO_D_OTYPER= 0x00000000;	    /* outputs are push/pull */
	*GPIO_D_ODRLOW = 0;
}

#ifndef SIMULATOR
typedef struct tag_usart
{
	volatile unsigned short sr;
	volatile unsigned short Unused0;
	volatile unsigned short dr;
	volatile unsigned short Unused1;
	volatile unsigned short brr;
	volatile unsigned short Unused2;
	volatile unsigned short cr1;
	volatile unsigned short Unused3;
	volatile unsigned short cr2;
	volatile unsigned short Unused4;
	volatile unsigned short cr3;
	volatile unsigned short Unused5;
	volatile unsigned short gtpr;
} USART;

#define USART1  ((USART *) 0x40011000)	

void	_outchar( char c )
{
 	while (( USART1->sr & (1<<7))==0);
	USART1->dr = (unsigned short) c;
}
#endif


void main(void)
{
	flag = 0;
	ms = 0;
	gpio_init();
	timer7_init();
#ifndef SIMULATOR 
	_outchar( '\n' );
#endif
	while( 1 )
	{
#ifdef SIMULATOR
		*GPIO_D_ODRLOW = flag;
		*GPIO_D_ODRLOW = flag;
		//*TIM7_EGR |= UG;   /* Ok */
		*GPIO_D_ODRLOW = flag;
		*GPIO_D_ODRLOW = flag;
#else
//		_outchar( flag+'0' );
#endif		
	}
}

