/*
 * 	systick_irq.c
 *	Arbbok ug4 uppgift 6.3
 *  Anslut Bargraphs till Port D
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm volatile(
	" LDR R0,=0x2001C000\n"		/* set stack */
	" MOV SP,R0\n"
	" BL main\n"				/* call main */
	" B .\n"					/* never return */
	) ;
}

#define		STK_CTRL  	((volatile unsigned int *)(0xE000E010))  
#define		STK_LOAD  	((volatile unsigned int *)(0xE000E014))  
#define		STK_VAL  	((volatile unsigned int *)(0xE000E018))  

void	systick_irq_handler( void );

void delay_1mikro( void )
{
	/* SystemCoreClock = 168000000 */
	*STK_CTRL = 0;
	*STK_LOAD = ( 168-1 );
	*STK_VAL = 0;
	*STK_CTRL = 7;
}


static volatile int	systick_flag;
static volatile int	delay_count;

void	systick_irq_handler( void )
{
	*STK_CTRL = 0;
	delay_count -- ;
	if( delay_count > 0 )
		delay_1mikro();
	else
		systick_flag = 1;
}


#define		GPIO_MODER		((volatile unsigned int *)		0x40020C00)  
#define		GPIO_OTYPER 	((volatile unsigned short *)	0x40020C04)  
#define		GPIO_OSPEEDR	((volatile unsigned int *)		0x40020C08)  
#define		GPIO_ODR_LOW	((volatile unsigned char *)		0x40020C14)  
#define		GPIO_ODR_HIGH	((volatile unsigned char *)		0x40020C15)  

void init_app( void )
{
	/* PORT D0-7 */
	*GPIO_MODER	 	= 0x55555555;	/* bits 0-15 are outputs */
	*GPIO_OTYPER 	= 0x00000000;	/* outputs are push/pull */	
	*GPIO_OSPEEDR 	= 0x55555555;	/* medium speed */
	
	*((void (**)(void) ) 0x2001C03C ) = systick_irq_handler;
}
#define	SIMULATOR


#ifdef SIMULATOR
#define DELAY_COUNT 1000
#else
#define DELAY_COUNT	100000
#endif

void	delay( unsigned int count )
{
	if( count == 0)
		return;
	delay_count = count;
	systick_flag = 0;
	delay_1mikro();
}


void main(void)
{
	unsigned char	c = 0;
	init_app();
	*GPIO_ODR_LOW = 0;
	delay( DELAY_COUNT );
	*GPIO_ODR_LOW = 0xFF;
	while(1)
	{
		if( systick_flag )
			break;
		/* Parallell code ... */
		*GPIO_ODR_HIGH = c;
		c++;
	}
	*GPIO_ODR_LOW = 0;
}
