/*
 * 	usart_polling_2.c
 *
 */

__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm volatile(
	" LDR R0,=0x2001C000\n"		
	" MOV SP,R0\n"
	" BL main\n"				
	" B .\n"					
	) ;
}


typedef struct tag_usart
{
	volatile unsigned short sr;
	volatile unsigned short Unused0;
	volatile unsigned short dr;
	volatile unsigned short Unused1;
	volatile unsigned short brr;
	volatile unsigned short Unused2;
	volatile unsigned short cr1;
	volatile unsigned short Unused3;
	volatile unsigned short cr2;
	volatile unsigned short Unused4;
	volatile unsigned short cr3;
	volatile unsigned short Unused5;
	volatile unsigned short gtpr;
} USART;

#define USART1  ((USART *) 0x40011000)	
#define USART2  ((USART *) 0x40004400)	

void init_app( void )
{
#ifdef USBDM	
	__asm(" LDR R0,=0x08000209\n BLX R0\n");	/* dbgARM:init_pll */
	//__asm(" LDR R0,=0x0800020D\n BLX R0\n");	/* dbgARM:init_uart fung ej med GDB*/
	
	*((volatile unsigned long *)0x40023844) |= 0x10; 		/* Enable USART 1 clock */
	*((volatile unsigned long *)0x40023830) |= 1; 			/* Enable port A */
	
	*((volatile unsigned long *)0x40023824)	|= 0x10; 	/* Reset USART1 */	
	*((volatile unsigned long *)0x40023824)	&= ~0x10; 	
	*((volatile unsigned long *)0x40023810) |= 1; 		/* Reset port A */
	*((volatile unsigned long *)0x40023810) &= ~1; 		/* Reset port A */

	/* Connect USART pins to AF */
	*((volatile unsigned int *)	0x40020024) |= 0x770;
	/* PA9 - USART1 TX  */
	/* PA10 - USART1 RX */
	*((volatile unsigned int *)	0x40020000) |= 0x00280000;	/* Pins 9 and 10 are AF */
	*((volatile unsigned int *)	0x4002000C) |= 0x00100000;	/* Pin 10 pull up */
	*((volatile unsigned short *)	0x40011008) = 0x2D9;	/* Set UART baudrate (115 200) */
	*((volatile unsigned short *)	0x4001100C) |= 0x200C;	/* Enable USART and TE/RX */
#endif	
}



void	_outchar1( char c )
{
 	while (( USART1->sr & (1<<7))==0);
	USART1->dr = (unsigned short) c;
}

char	_tstchar1( void )
{
	if( (USART1->sr & (1<<5) )==0)
		return 0;
	return (char) USART1->dr;
}
	

char	_inchar1( void )
{
	char c;
 	while ( (c=_tstchar1() )==0);
	return c;	
}

void	_outchar2( char c )
{
 	while (( USART2->sr & (1<<7))==0);
	USART2->dr = (unsigned short) c;
}

char	_tstchar2( void )
{
	if( (USART2->sr & (1<<5) )==0)
		return 0;
	return (char) USART2->dr;
}
	

char	_inchar2( void )
{
	char c;
 	while ( (c=_tstchar2() )==0);
	return c;	
}


void main(void)
{
	char c;
#define	EN		(1<<13)
#define	TE		(1<<3)
#define	RE		(1<<2)
	USART2->cr1 = EN | TE | RE;
	while(1){
        c = _inchar1();
        _outchar2( c );
        c = _inchar2();
        _outchar1( c );
	}
 }

