/*
 * 	ftosl.c
 *
 */
void startup(void) __attribute__((naked)) __attribute__((section (".start_section")) );

void startup ( void )
{
__asm volatile(
	" LDR R0,=0x2001C000\n"		/* set stack */
	" MOV SP,R0\n"
	" BL main\n"				/* call main */
	" B .\n"					/* never return */
	) ;
}

union float_long
{
    float 	f;
    long 	l;
};


long ftosl (float a1)
{
	union 	float_long fl;
	int 		exp;
	char		sign;
	long 		l;
	
	fl.f = a1;
	
	if (!fl.l)
		return (0);
	sign = 0;
	if( fl.l & 0x80000000 )
	{
		sign++;
	}
	
	exp = (((unsigned long)( fl.l ) >> 23) & 
			(unsigned int) 0x00FF) - 127 - 23;

	l = ((( fl.l ) & (unsigned long)0x007FFFFF) | 0x00800000 );
	
	if (exp > 8)
		return 2147483647; /* största möjliga ‘long int’ */
	if (exp +25 < 0)
		return -2147483648; /* minsta möjliga ‘long int’ */
		
	/* exponenten ska vara noll... */
	if( exp > 0 )
	{	/* skifta mantissan till vänster */
		l = l << exp;
	}
	
	if (exp < 0 )
	{	/* skifta mantissan till höger */
		l = l >> -exp;
	}
	
	if( sign )
		return -l;
	return l;

}


void main( void )
{
		long i;
		i = ftosl( -1.0 );
		i = ftosl( 1.0 );
		i = ftosl( -100.0 );
		i = ftosl( 100.0 );
}

