/*
 * 	malloctest.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
 __asm volatile(" LDR  R0,=__stack_top\n");
 __asm volatile(" MOV  SP,R0\n");
 __asm volatile(" BL   crt_init\n");
 __asm volatile(" BL   main\n");
 __asm volatile(" BL   crt_deinit\n");
 __asm volatile(" .globl _exit\n");
 __asm volatile("_exit: B _exit\n");
}

static void crt_init() {
  extern char __bss_start; 
  extern char __bss_end; 
  extern char __heap_low; 
  extern char __heap_top; 
  char *s;
  s = &__bss_start;
  while( s < &__bss_end)
    *s++ = 0;
  s = &__heap_low;
  while( s < &__heap_top )
    *s++ = 0;
}

static void crt_deinit() {
}

#include 	<errno.h>
static char *heap_end;
char * _sbrk( int incr) {
  extern char __heap_low; 
  extern char __heap_top; 
  char *prev_heap_end;
  if (heap_end == 0) {
    heap_end = &__heap_low;
  }
  prev_heap_end = heap_end;
 
  if (heap_end + incr > &__heap_top) {
    /* Heap and stack collision */
    errno = ENOMEM;
    return (char *)-1;
  }
  heap_end += incr;
  return (char *) prev_heap_end;
}


void main(void)
{
   	char str1[]="Beginning of string";
  	char str2[]="Continuation of string";
	char *s1,*s2;
	s1 = malloc( strlen(str1)+1 );
    if( s1 == 0 ) exit(-1);
    strcpy( s1, str1 );
    s2 = realloc( s1, strlen(str1)+1 );
    if( s2 == 0 ) exit(-1);
    strcat( s2,str2 );
	free( s2 );
}

