/*
 * 	startup-crt.c
 *  includes: _crt_init, _crt_deinit, _sbrk for malloc-support.
 *  template functions for stdio: 
 */
#include	<errno.h>
#include 	<sys/stat.h>
#include	<stdio.h>
#include 	<stdlib.h>
  
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=__stack_top\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL _crt_init\n");			/* init C-runtime library */
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(" BL _crt_deinit\n");			/* deinit C-runtime library */
__asm__ volatile(".L1: B .L1\n");				/* never return */
	
}
static char *heap_end;

char * _sbrk(int incr) {
extern char __heap_low; /* Defined by the linker */
extern char __heap_top; /* Defined by the linker */
	char *prev_heap_end;
 	if (heap_end == 0) {
		heap_end = &__heap_low;
	}
	prev_heap_end = heap_end;
	if (heap_end + incr > &__heap_top) {		
		errno = ENOMEM;
			return (char *)-1;
	}
	heap_end += incr;
	return (char *) prev_heap_end;	
}

__attribute__ ( (used) )		/* Will be optimised away otherwise... */
volatile static void _crt_init() {
extern char __heap_low; /* Defined by the linker */
extern char __heap_top; /* Defined by the linker */
extern char __bss_start__; 	/* Defined by the linker */
extern char __bss_end__; 	/* Defined by the linker */
	 char *s;
	heap_end = 0;
	 s = &__bss_start__;
	 while( s < &__bss_end__ )
		 *s++ = 0;
	 s = &__heap_low;
	 while( s < &__heap_top )
		 *s++ = 0;
}

__attribute__ ( (used) )		/* Will be optimised away otherwise... */
volatile static void _crt_deinit() {
}


/* STDIO-templates */
int _close(int file) { return -1; }
int _open(const char *name, int flags, int mode) { return -1; }
int _isatty(int file) { return 1; }
int _fstat(int file, struct stat *st) { st->st_mode = S_IFCHR; return 0; }
int _lseek(int file, int ptr, int dir) { return 0;}
// int _read(int file, char *ptr, int len) { return 0; }  replaced below
// int _write(int file, char *ptr, int len) { return 0; } replaced below


/* USART stdio-support */
typedef struct tag_usart
{
	volatile unsigned short sr;
	volatile unsigned short Unused0;
	volatile unsigned short dr;
	volatile unsigned short Unused1;
	volatile unsigned short brr;
	volatile unsigned short Unused2;
	volatile unsigned short cr1;
	volatile unsigned short Unused3;
	volatile unsigned short cr2;
	volatile unsigned short Unused4;
	volatile unsigned short cr3;
	volatile unsigned short Unused5;
	volatile unsigned short gtpr;
} USART;

#define USART1  ((USART *) 0x40011000)	

void	_outchar( char c )
{
 	while (( USART1->sr & 0x80)==0);
	USART1->dr = (unsigned short) c;
	if( c == '\n')
			_outchar('\r');
}

char	_tstchar( void )
{
	if( (USART1->sr & 0x20)==0)
		return 0;
	return (char) USART1->dr;
}
	

char	_inchar( void )
{
	char c;
 	while ( (c=_tstchar() )==0);
	return c;	
}
int _read(int file, char *ptr, int len) {
	int todo;
	if(len == 0)
		return 0;
	for(todo = 1; todo <= len; todo++) {
		*ptr++ = _inchar();
	}
	return todo-1;
}
 
int _write(int file, char *ptr, int len) {
	int todo;
 
	for (todo = 0; todo < len; todo++) {
		/* write character to usart1 */
		_outchar( *ptr++ );
	}
	return len;
}



/* Main program */
void main(void)
{
	printf( "Hello World\n");
}

