/*
 * Lab 3_1.c
 * Rita enkel geometri på grafikdisplayen (för att testa drivrutin)
 */

#define	SIMULATOR
//#define	USBDM

void startup(void) __attribute__((naked)) __attribute__((section (".start_section")) );

void startup ( void )
{
__asm volatile(
	" LDR R0,=0x2001C000\n"		/* set stack */
	" MOV SP,R0\n"
	" BL main\n"				/* call main */
	".L1: B .L1\n"				/* never return */
	) ;
}

#define		STK_CTRL 	((volatile unsigned int *)(0xE000E010))  
#define		STK_LOAD 	((volatile unsigned int *)(0xE000E014))  
#define		STK_VAL 	((volatile unsigned int *)(0xE000E018))  

/* FRÅN LAB 2.2 */
void delay_250ns( void )
{
#ifdef	SIMULATOR
	return;
#endif
	/* SystemCoreClock = 168000000 */
	*STK_CTRL = 0;
	*STK_LOAD = ( (168/4) -1 );
	*STK_VAL = 0;
	*STK_CTRL = 5;
	while( (*STK_CTRL & 0x10000 )== 0 );
	*STK_CTRL = 0;
}

void	delay_micro(unsigned int us)
{
#ifdef	SIMULATOR
	return;
#endif
	while( us > 0 )
	{
		delay_250ns();
		delay_250ns();
		delay_250ns();
		delay_250ns();
		us--;
	}
}

void	delay_milli(unsigned int ms)
{
#ifdef	SIMULATOR
	return;
#endif
	while( ms > 0 )
	{
		delay_micro( 1 );
		delay_micro( 1000 );
		ms--;
	}
}

void delay_500ns( void )
{
#ifdef	SIMULATOR
	return;
#endif
	delay_250ns();
	delay_250ns();
}

/* ----------------------------------------------------------------- */
#define		GPIO_E_BASE		0x40021000		/* MD407 port E */

#define		GPIO_E_MODER 	((volatile unsigned int *)	(GPIO_E_BASE))  
#define		GPIO_E_OTYPER 	((volatile unsigned short *)(GPIO_E_BASE+0x4))  
#define		GPIO_E_OSPEEDR 	((volatile unsigned int *)	(GPIO_E_BASE+0x8))  
#define		GPIO_E_PUPDR 	((volatile unsigned int *)	(GPIO_E_BASE+0xC))  

/* Byte address definitions */
#define		GPIO_E_IDRHIGH 	((volatile unsigned char *)	(GPIO_E_BASE+0x10+1))  
#define		GPIO_E_ODRLOW 	((volatile unsigned char *)	(GPIO_E_BASE+0x14))  
#define		GPIO_E_ODRHIGH 	((volatile unsigned char *)	(GPIO_E_BASE+0x14+1))  

/* Register bit definitions */
#define	B_E		0x40
#define	B_RST	0x20
#define	B_CS2	0x10
#define	B_CS1	8
#define	B_SELECT	4			
#define	B_RW	2
#define	B_DI	1
#define	B_RS	1

/* LCD display commands */
#define LCD_ON				0x3F
#define LCD_OFF				0x3E
#define LCD_SET_ADD			0x40
#define LCD_SET_PAGE		0xB8
#define LCD_DISP_START		0xC0
#define LCD_BUSY			0x80

/* Graphic display */
static void	graphic_ctrl_bit_set( unsigned char x )
{	
	*GPIO_E_ODRLOW|= ( ~B_SELECT & x );
}
static void	graphic_ctrl_bit_clear( unsigned char x )
{
	*GPIO_E_ODRLOW &= ( ~B_SELECT & ~x );
}

static void select_controller( unsigned char controller)
{
switch(controller){
	case 0:				graphic_ctrl_bit_clear(B_CS1|B_CS2);  break;
	case B_CS1 : 		graphic_ctrl_bit_set(B_CS1); graphic_ctrl_bit_clear(B_CS2); break;
	case B_CS2 : 		graphic_ctrl_bit_set(B_CS2); graphic_ctrl_bit_clear(B_CS1);  break;
	case B_CS1|B_CS2 : 	graphic_ctrl_bit_set(B_CS1|B_CS2);  break;
	}
}

static void graphic_wait_ready(void)
{
	unsigned char c;
	
	graphic_ctrl_bit_clear( B_E ); 
	*GPIO_E_MODER	= 0x00005555;	/* b15-8 are inputs, 7-0 are outputs */	
	graphic_ctrl_bit_clear( B_DI ); 
	graphic_ctrl_bit_set( B_RW ); 
	delay_500ns();
	
	while( 1 )
	{
		graphic_ctrl_bit_set( B_E ); 
		delay_500ns();
		c = *GPIO_E_IDRHIGH & 0x80;	
		graphic_ctrl_bit_clear( B_E ); 
		delay_500ns();
		if( c == 0 )break;
	}
	*GPIO_E_MODER	 = 0x55555555;	/* all bits outputs */
	graphic_ctrl_bit_set( B_E );
}

static unsigned char  graphic_read(unsigned char controller)
{
	unsigned char c;
	*GPIO_E_MODER	= 0x00005555;	/* b15-8 are inputs, 7-0 are outputs */	
	select_controller( controller );

	graphic_ctrl_bit_clear( B_E ); 
	graphic_ctrl_bit_set( B_DI | B_RW ); 
	delay_500ns();
	graphic_ctrl_bit_set( B_E ); 
	delay_500ns();
	c = *GPIO_E_IDRHIGH;	

	graphic_ctrl_bit_clear( B_E );
	*GPIO_E_MODER	 = 0x55555555;	/* all bits outputs */


	if( controller & B_CS1 )
	{
		select_controller( B_CS1);
		graphic_wait_ready();
	}
	if( controller & B_CS2 )
	{
		select_controller( B_CS2);
		graphic_wait_ready();
	}
	return c;
}

static void graphic_write(unsigned char val, unsigned char controller)
{
	*GPIO_E_ODRHIGH = val;
	delay_500ns();
	graphic_ctrl_bit_set( B_E ); 
	delay_500ns();
	graphic_ctrl_bit_clear( B_E ); 
	
	if( controller & B_CS1 )
	{
		select_controller( B_CS1);
		graphic_wait_ready();
	}
	if( controller & B_CS2 )
	{
		select_controller( B_CS2);
		graphic_wait_ready();
	}
	
	*GPIO_E_ODRHIGH = 0;
	graphic_ctrl_bit_set( B_E ); 
	select_controller( 0 );
}

static unsigned char  graphic_read_data(unsigned char controller)
{
	graphic_read(controller);
	return graphic_read(controller);
}

static void graphic_writeCommand(unsigned char commandToWrite, unsigned char controller)
{
	select_controller( controller );
	graphic_ctrl_bit_clear( B_E ); 
	graphic_ctrl_bit_clear( B_DI | B_RW ); 
	graphic_write(commandToWrite, controller);
}

static void graphic_writeData(unsigned char data, unsigned char controller)
{
	select_controller( controller );
	graphic_ctrl_bit_clear( B_E ); 
	graphic_ctrl_bit_set( B_DI ); 
	graphic_ctrl_bit_clear( B_RW ); 
	graphic_write(data, controller);
}

void graphic_clear_screen(void)
{
	unsigned char i, j;
	for(j = 0; j < 8; j++)
	{
		graphic_writeCommand(LCD_SET_PAGE | j, B_CS1|B_CS2 );
		graphic_writeCommand(LCD_SET_ADD | 0, B_CS1|B_CS2 );
		for(i = 0; i <= 63; i++){
			graphic_writeData(0,  B_CS1|B_CS2);
		}
  }
}

void pixel( int x, int y, int set )
{
	unsigned char mask,c, controller;
	int	index;
	
	if( (x > 127 ) || (y > 63) )
	return;
	
	index = y/8;
	switch( y%8 )
	{
		case 0: mask = 1; break;
		case 1: mask = 2; break;
		case 2: mask = 4; break;
		case 3: mask = 8; break;
		case 4: mask = 0x10; break;
		case 5: mask = 0x20; break;
		case 6: mask = 0x40; break;
		case 7: mask = 0x80; break;
		default:
			mask = 0xAA;
	}
	if( set == 0)
		mask = ~mask;
		

	if(x >= 64){
		controller = B_CS2;
		x = x - 64;
	}else
		controller = B_CS1;
		
	graphic_writeCommand(LCD_SET_ADD | x, controller );
	graphic_writeCommand(LCD_SET_PAGE | index, controller );
	c = graphic_read_data( controller );
	graphic_writeCommand(LCD_SET_ADD | x, controller );
	if( set )
		mask = mask | c;
	else
		mask = mask & c;
	graphic_writeData( mask, controller);
}

void graphic_initalize(void)
{
	graphic_ctrl_bit_set( B_E ); 
	delay_micro(10);

	graphic_ctrl_bit_clear(B_CS1|B_CS2|B_RST|B_E);  
	delay_milli( 30 );
	graphic_ctrl_bit_set(B_RST); 	
	delay_milli( 100 );
	graphic_writeCommand(LCD_OFF, B_CS1|B_CS2);
	graphic_writeCommand(LCD_ON, B_CS1|B_CS2);
	graphic_writeCommand(LCD_DISP_START, B_CS1|B_CS2);
	graphic_writeCommand(LCD_SET_ADD, B_CS1|B_CS2);
	graphic_writeCommand(LCD_SET_PAGE, B_CS1|B_CS2);
	select_controller( 0 );
}

void	init_app(void)
{
#ifdef USBDM	
	/* starta klockor port D och E */
	* ( (unsigned long *) 0x40023830) = 0x18;
	__asm( 	" BL =0x08000209\n");
#endif	
	/* PORT E */
	*GPIO_E_MODER	= 0x55555555;	/* all bits outputs */
	*GPIO_E_OTYPER 	= 0x00000000;	/* outputs are push/pull */	
	*GPIO_E_OSPEEDR = 0x55555555;	/* medium speed */
	*GPIO_E_PUPDR 	= 0x55550000;	/* inputs are pull up */
}

void main(void)
{
	int	i;

	init_app();	
	graphic_initalize();
#ifndef	SIMULATOR
	graphic_clear_screen();
#endif

	for( i = 0; i < 128; i++ )
		pixel( i, 10 , 1 );

	for( i = 0; i < 64; i++ )
		pixel( 10, i , 1 );

	delay_milli( 500 );


	for( i = 0; i < 128; i++ )
		pixel( i, 10 , 0 );

	for( i = 0; i < 64; i++ )
		pixel( 10, i , 0 );
 }
