/*
 * Lab 3_1.c
 * Rita enkel geometri på grafikdisplayen (för att testa drivrutin)
 * LCD-modul DATA   PE8-15
 * LCD-modul CTRL   PE0-7
 */

#define	SIMULATOR
//#define	USBDM

__attribute__((naked)) 
__attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		
__asm__ volatile(" MOV SP,R0\n");		
__asm__ volatile(" BL main\n");		
__asm__ volatile(" B .\n");		
}

#define		STK_CTRL 	((volatile unsigned int *)(0xE000E010))  
#define		STK_LOAD 	((volatile unsigned int *)(0xE000E014))  
#define		STK_VAL 	((volatile unsigned int *)(0xE000E018))  

/* FRÅN LAB 2.2 */
void delay_250ns( void )
{
	/* SystemCoreClock = 168000000 */
	*STK_CTRL = 0;
	*STK_LOAD = ( (168/4) -1 );
	*STK_VAL = 0;
	*STK_CTRL = 5;
	while( (*STK_CTRL & 0x10000 )== 0 );
	*STK_CTRL = 0;
}


void	delay_micro(unsigned int us)
{
	while( us > 0 )
	{
		delay_250ns();
		delay_250ns();
		delay_250ns();
		delay_250ns();
		us--;
	}
}

void	delay_milli(unsigned int ms)
{
	while( ms > 0 )
	{
#ifdef	SIMULATOR
		delay_micro( 1 );
#else
		delay_micro( 1000 );
#endif
		ms--;
	}
}

/* Graphic display */
__attribute__((naked)) 
void graphic_initalize(void)
{
	__asm volatile (" .HWORD	0xDFF0\n");	
	__asm volatile (" BX LR\n");		
}
 
__attribute__((naked)) 
void graphic_clear_screen(void)
{
    __asm volatile (" .HWORD	0xDFF1\n");		
	__asm volatile (" BX LR\n");		
}
 
__attribute__((naked))
void graphic_pixel_set( int x, int y)
{
    __asm volatile (" .HWORD	0xDFF2\n");		
	__asm volatile (" BX LR\n");		
}
 
__attribute__((naked))
void graphic_pixel_clear( int x, int y)
{
    __asm volatile (" .HWORD	0xDFF3\n");		
	__asm volatile (" BX LR\n");		
}
  

void	init_app(void)
{
#ifdef USBDM	
	/* starta klockor port D och E */
	* ( (unsigned long *) 0x40023830) = 0x18;
	__asm( 	" BL =0x08000209\n");
#endif	
}


void line (int x1,int x2,int y1,int y2)
{
    int k100;
    if( x2 >= x1)
        k100 = ((y2-y1) * 100)/(x2-x1);
    else
         k100 = ((y2-y1) * 100)/(x2-x1);
          
    int deltax,deltay;
    
    for( deltax = x1; deltax <= x2; deltax++)
    {
        deltay = (k100 * deltax)/100;
        graphic_pixel_set( deltax, deltay );
    }
}
void line0 (int x1,int x2,int y1,int y2)
{
    int k;
    k = (y2-y1)/(x2-x1);
             
    int deltax,deltay;
    
    for( deltax = x1; deltax <= x2; deltax++)
    {
        deltay = (k * deltax);
        graphic_pixel_set( deltax, deltay );
    }
}

static void line1 (int x1,int y1,int x2,int y2)
{
  int k100;
  int deltax,deltay;
  k100 = (y2-y1)*64/(x2-x1);
                 
        
  for( deltax = x1; deltax <= x2; deltax++)
  {
    deltay = (k100 * deltax)/64;
    graphic_pixel_set( deltax, y1+deltay );
  }
}

static void line2 (int x1,int y1,int x2,int y2)
{
  int k100;
  int deltax,deltay;
  k100 = (x2-x1)*64/(y2-y1);
                 
        
  for( deltay = y1; deltay <= y2; deltay++)
  {
    deltax = (k100 * deltay)/64;
    graphic_pixel_set( x1+deltax, deltay );
  }
}



typedef struct coord
{
	char x,y;
} COORD, *PCOORD;


typedef struct line
{
    COORD   start;
    COORD   end;
} LINE, *PLINE;

int draw_line( PLINE l )
{
    /* Sanitetskontroll.. */
	if( (l->start.x < 1)||(l->start.x > 128) )
		return 0;
	if( (l->start.y < 1)||(l->start.y > 64) )
		return 0;
	if( (l->end.x < 1)||(l->end.x > 128) )
		return 0;
	if( (l->end.y < 1)||(l->end.y > 64) )
		return 0;

    if( (l->end.y - l->start.y) > (l->end.x - l->start.x))
    {
       /* rita upp i från och ned */
        if( l->start.y > l->end.y )
            line2( l->end.x, l->end.y, l->start.x,l->start.y );
        else
            line2( l->start.x, l->start.y, l->end.x,l->end.y );
       
    }else{
        /* rita från vänster till höger */
        if( l->start.x > l->end.x )
            line1( l->end.x, l->end.y, l->start.x,l->start.y );
        else
            line1( l->start.x, l->start.y, l->end.x,l->end.y );
     }
 	return 1;
}


typedef struct rect
{
    COORD   origo;
    COORD   size;
} RECT, *PRECT;


struct line0
{
    struct coord0
    {
        int x,y;
    } start, end;
};


int draw_rect( PRECT r )
{
    LINE tmp;
    tmp.start.x = r->origo.x;
    tmp.start.y = r->origo.y;
    tmp.end.x = r->origo.x + r->size.x;
    tmp.end.y = r->origo.y;
    draw_line( &tmp );
    
    tmp.start.x = tmp.end.x;
    tmp.start.y = tmp.end.y;
    tmp.end.x = tmp.start.x;
    tmp.end.y = tmp.start.y + r->size.y;
    draw_line( &tmp );

    tmp.start.x = tmp.end.x;
    tmp.start.y = tmp.end.y;
    tmp.end.x = tmp.start.x - r->size.x;
    tmp.end.y = tmp.start.y;
    draw_line( &tmp );

    tmp.start.x = r->origo.x;
    tmp.start.y = r->origo.y+r->size.y;
    tmp.end.x = r->origo.x;
    tmp.end.y = r->origo.y;
    draw_line( &tmp );


}


LINE t1 = {1,64, 128,1};
LINE t2 = {1,1, 128,64};
LINE t3 = {1,1, 128,64};
LINE t4 = {128,1, 1,64};

RECT me = {20,20, 40,40};


LINE t5 = {10,1, 10,64};

LINE t6 = {1,10, 128,11};


void main(void)
{
	int	i;
	init_app();	
	graphic_initalize();
	graphic_clear_screen();
 
	draw_line( &t5 );
	graphic_clear_screen();
	draw_line( &t6 );
	graphic_clear_screen();

   
    
    draw_rect( &me );  
    
    
	draw_line( &t1 );
	graphic_clear_screen();
	draw_line( &t2 );
	graphic_clear_screen();
	draw_line( &t3 );
	graphic_clear_screen();
	draw_line( &t4 );	
	graphic_clear_screen();
   

	for( i = 1; i <= 128; i++ )
		graphic_pixel_set( i, 10 );
	for( i = 1; i <= 64; i++ )
		graphic_pixel_set( 10, i );
	delay_milli( 500 );
	for( i = 1; i <= 128; i++ )
		graphic_pixel_clear( i, 10 );
	for( i = 1; i <= 64; i++ )
		graphic_pixel_clear( 10, i );
 }
