/*
 * Lab 3_2.c
 * Automatiskt PONG-spel
 * LCD-modul DATA   PE8-15
 * LCD-modul CTRL   PE0-7
 */
#define	SIMULATOR
//#define	USBDM

__attribute__((naked)) 
__attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		
__asm__ volatile(" MOV SP,R0\n");		
__asm__ volatile(" BL main\n");		
__asm__ volatile(" B .\n");		
}

#define		STK_CTRL 	((volatile unsigned int *)(0xE000E010))  
#define		STK_LOAD 	((volatile unsigned int *)(0xE000E014))  
#define		STK_VAL 	((volatile unsigned int *)(0xE000E018))  

/* FRÅN LAB 2.2 */
void delay_250ns( void )
{
	/* SystemCoreClock = 168000000 */
	*STK_CTRL = 0;
	*STK_LOAD = ( (168/4) -1 );
	*STK_VAL = 0;
	*STK_CTRL = 5;
	while( (*STK_CTRL & 0x10000 )== 0 );
	*STK_CTRL = 0;
}


void	delay_micro(unsigned int us)
{
	while( us > 0 )
	{
		delay_250ns();
		delay_250ns();
		delay_250ns();
		delay_250ns();
		us--;
	}
}

void	delay_milli(unsigned int ms)
{
	while( ms > 0 )
	{
#ifdef	SIMULATOR
		delay_micro( 1 );
#else
		delay_micro( 1000 );
#endif
		ms--;
	}
}

/* Graphic display */
__attribute__((naked)) 
void graphic_initalize(void)
{
	__asm volatile (" .HWORD	0xDFF0\n");	
	__asm volatile (" BX LR\n");		
}
 
__attribute__((naked)) 
void graphic_clear_screen(void)
{
    __asm volatile (" .HWORD	0xDFF1\n");		
	__asm volatile (" BX LR\n");		
}
 
__attribute__((naked))
void graphic_pixel_set( int x, int y)
{
    __asm volatile (" .HWORD	0xDFF2\n");		
	__asm volatile (" BX LR\n");		
}
 
__attribute__((naked))
void graphic_pixel_clear( int x, int y)
{
    __asm volatile (" .HWORD	0xDFF3\n");		
	__asm volatile (" BX LR\n");		
}
  

/* Typdefinitioner */
typedef struct tPoint
{
	unsigned char x;
	unsigned char y;
}POINT;

#define MAX_POINTS 20
typedef struct tGeometri
{
	int	numpoints;
	int	sizex;
	int	sizey;
	POINT	px[ MAX_POINTS ];
} GEOMETRY, *PGEOMETRY;

typedef struct tObj{
	PGEOMETRY geo;
	int	dirx,diry;
	unsigned int	posx,posy;
	void (* draw ) (struct tObj *);
	void (* clear ) (struct tObj *);
	void (* move ) (struct tObj *);
	void (* set_speed ) (struct tObj *, int, int);
} OBJECT, *POBJECT;


/* Definiera objektets funktioner (draw, clear,move,set_speed */


void draw_ballobject(POBJECT o)
{
    int	i;
	for( i = 0; i < o->geo->numpoints; i++ )
	{
		graphic_pixel_set( o->geo->px[i].x + o->posx, o->geo->px[i].y + o->posy );
	}
}

typedef struct tPoint0{
   unsigned char x;
   unsigned char y;
  struct tPoint0 *next;
} POINTLIST;


void clear_ballobject(POBJECT o)
{
    int	i;
	for( i = 0; i < o->geo->numpoints; i++ )
	{
		graphic_pixel_clear( o->geo->px[i].x + o->posx, o->geo->px[i].y + o->posy );
	}
}

void	set_ballobject_speed(POBJECT o, int speedx, int speedy)
{ 
	o->dirx = speedx;
	o->diry = speedy;	
}

void	move_ballobject(POBJECT o )
{
	/* move object in direction */
	int cx, cy;
	
	o->clear(o);	/* rubout current object */

	cx = o->posx + o->dirx;
	cy = o->posy + o->diry;

	/* should object bounce?  */
	if( cx+ o->geo->sizex > 128) 
	{
		o->dirx = - o->dirx;
		cx = 128 - o->geo->sizex;
	} 
	else if( cx<1 )
	{
		o->dirx = - o->dirx;
		cx = 1;
	}
	
	if( cy + o->geo->sizey > 64) 
	{
		o->diry = - o->diry;
		cy = 64 - o->geo->sizey;
	} 
	else if( cy<1 )
	{
		o->diry = - o->diry;
		cy = 1;
	}		
	/* save new position */
	o->posx =  cx;
	o->posy =  cy;
	o->draw(o);
}

void init_app( void )
{
#ifdef USBDM	
	/* starta klockor port D och E */
	* ( (unsigned long *) 0x40023830) = 0x18;
	__asm( 	" BL =0x08000209\n");
#endif	
}

/* Deklarera och instansiera ett objekt i form av en liten boll */
/* Skapa ett objekt i form av en boll med statiska och dynamiska egenskaper */	
GEOMETRY ball_geometry =
{
	12,		// numpoints
	4,4,	// sizex,sizey
	{   // px[]
		{0,1},{0,2},{1,0},{1,1},{1,2},{1,3},{2,0},{2,1},{2,2},{2,3},{3,1},{3,2}
	}
};

static OBJECT	ballobject =
{
	&ball_geometry,			// geometri för en boll
	0,0,				// initiala riktningskoordinater
	1,1,				// initial startposition
	draw_ballobject,
	clear_ballobject,
	move_ballobject,	
	set_ballobject_speed
};

int main(int argc, char **argv)
{
	POBJECT p = &ballobject;
	init_app();	
	graphic_initalize();
	graphic_clear_screen();
	p->set_speed( p, 4, 1);
	
	while( 1 )
	{
		p->move( p );
		delay_milli(40);	/* 50 frames/sec */
	}
}




void	move_object(POBJECT o ) {}
void	draw_object(POBJECT o ) {}
void	clear_object(POBJECT o ) {}
void	set_object_speed(POBJECT o, int x, int y ) {}


static OBJECT ball = {
   &ball_geometry,
   0, 0,
   1, 1,
   draw_object,
   clear_object,
   move_object,
   set_object_speed
}; 

void	alternate_move_object(POBJECT o ) {}


void test()
{
    OBJECT b;
    
    b.geo = &ball_geometry;
    b.dirx = 0; b.diry = 0;
    b.posx = 64; b.posy = 32;
    b.draw = draw_object;
    b.clear = clear_object;
    b.move = move_object;
    b.set_speed = set_object_speed;
    
    POBJECT pb;
    pb = &b;
    
    pb->set_speed( pb, 1,1);
    
}



