/*
 * Lab 3_3.c
 * Automatiskt PONG-spel
 */


void startup(void) __attribute__((naked)) __attribute__((section (".start_section")) );

/* Built in DBG-routines, absolute addresses */
typedef void (* function1 )(void);  

#define hwInit  ((function1)    (0x08000201))   /* do hardware initialisation */
#define exitDBG ((function1)    (0x08000205))   /* reentry in debugger */

//#define GDB_DEBUG

static void Init( void )
{
#ifdef GDB_DEBUG
   hwInit();
#endif   
}

static void Exit( void )
{
    exitDBG();
}

void startup ( void )
{
asm volatile(
	" NOP\n"					/* executed by first 'trace'-command */
	" LDR SP,=0x2001C000\n"		/* set stack */
	" BL Init\n"				/* do hardware init */
	" BL main\n"				/* call main */
	" B  Exit\n"				/* exit to debugger */
	".L1: B .L1\n"				/* never return */
	) ;
}



#define		SysTickCtrl 	((volatile unsigned int *)(0xE000E010))  
#define		SysTickLoad 	((volatile unsigned int *)(0xE000E014))  
#define		SysTickVal 		((volatile unsigned int *)(0xE000E018))  

/* FRÅN LAB 2.2 */
void delay_250ns( void )
{
#ifdef	SIMULATOR
	return;
#endif
	/* SystemCoreClock = 168000000 */
	*SysTickCtrl = 0;
	*SysTickLoad = ( (168/4) -1 );
	*SysTickVal = 0;
	*SysTickCtrl = 5;
	while( (*SysTickCtrl & 0x10000 )== 0 );
	*SysTickCtrl = 0;
}


void	delay_micro(unsigned int us)
{
#ifdef	SIMULATOR
	return;
#endif
	while( us > 0 )
	{
		delay_250ns();
		delay_250ns();
		delay_250ns();
		delay_250ns();
		us--;
	}
}

void	delay_milli(unsigned int ms)
{
#ifdef	SIMULATOR
	return;
#endif
	while( ms > 0 )
	{
		delay_micro( 1 );
		delay_micro( 1000 );
		ms--;
	}
}



void delay_500ns( void )
{
#ifdef	SIMULATOR
	return;
#endif
	delay_250ns();
	delay_250ns();
}

/* ----------------------------------------------------------------- */



#define		PORT_DISPLAY_BASE		0x40021000		/* MD407 port E */


#define	B_E		0x40
#define	B_RST	0x20
#define	B_CS2	0x10
#define	B_CS1	8
#define	B_SELECT	4			
#define	B_RW	2
#define	B_DI	1
#define	B_RS	1

#define LCD_ON				0x3F
#define LCD_OFF				0x3E
#define LCD_SET_ADD			0x40
#define LCD_SET_PAGE		0xB8
#define LCD_DISP_START		0xC0
#define LCD_BUSY			0x80

#define		portModer 		((volatile unsigned int *)	(PORT_DISPLAY_BASE))  
#define		portOtyper 		((volatile unsigned short *)(PORT_DISPLAY_BASE+0x4))  
#define		portOspeedr 	((volatile unsigned int *)	(PORT_DISPLAY_BASE+0x8))  
#define		portPupdr 		((volatile unsigned int *)	(PORT_DISPLAY_BASE+0xC))  
#define		portIdr 		((volatile unsigned short *)(PORT_DISPLAY_BASE+0x10))  
#define		portIdrHigh		((volatile unsigned char *)(PORT_DISPLAY_BASE+0x11))  
#define		portOdrLow 		((volatile unsigned char *)(PORT_DISPLAY_BASE+0x14))  
#define		portOdrHigh 	((volatile unsigned char *)(PORT_DISPLAY_BASE+0x14+1))  


/* Graphic display */
static void	graphic_ctrl_bit_set( unsigned char x )
{	
	*portOdrLow|= ( ~B_SELECT & x );
}
static void	graphic_ctrl_bit_clear( unsigned char x )
{
	*portOdrLow &= ( ~B_SELECT & ~x );
}

static void select_controller(unsigned char controller)
{
switch(controller){
	case 0:				graphic_ctrl_bit_clear(B_CS1|B_CS2);  break;
	case B_CS1 : 		graphic_ctrl_bit_set(B_CS1); graphic_ctrl_bit_clear(B_CS2); break;
	case B_CS2 : 		graphic_ctrl_bit_set(B_CS2); graphic_ctrl_bit_clear(B_CS1);  break;
	case B_CS1|B_CS2 : 	graphic_ctrl_bit_set(B_CS1|B_CS2);  break;
	}
}


static void graphic_wait_ready(void)
{
	unsigned char c;
	
	graphic_ctrl_bit_clear( B_E ); 
	*portModer	= 0x00005555;	/* b15-8 are inputs, 7-0 are outputs */	
	graphic_ctrl_bit_clear( B_DI ); 
	graphic_ctrl_bit_set( B_RW ); 
	delay_500ns();
	
	while( 1 )
	{
		graphic_ctrl_bit_set( B_E ); 
		delay_500ns();
		c = *portIdrHigh & 0x80;	
		if( c == 0 )break;
		graphic_ctrl_bit_clear( B_E ); 
		delay_500ns();
	}
	*portModer	 = 0x55555555;	/* all bits outputs */
	graphic_ctrl_bit_set( B_E );
}

static unsigned char  display_read(unsigned char controller)
{
	unsigned char c;
	*portModer	= 0x00005555;	/* b15-8 are inputs, 7-0 are outputs */	
	select_controller( controller );

	graphic_ctrl_bit_clear( B_E ); 
	graphic_ctrl_bit_set( B_DI | B_RW ); 
	delay_500ns();
	graphic_ctrl_bit_set( B_E ); 
	delay_500ns();
	c = *portIdrHigh;	

	graphic_ctrl_bit_clear( B_E );
	*portModer	 = 0x55555555;	/* all bits outputs */


	if( controller & B_CS1 )
	{
		select_controller( B_CS1);
		graphic_wait_ready();
	}
	if( controller & B_CS2 )
	{
		select_controller( B_CS2);
		graphic_wait_ready();
	}
	return c;
}



static void graphic_write(unsigned char val, unsigned char controller)
{
	*portOdrHigh = val;
	select_controller( controller );
	delay_500ns();
	graphic_ctrl_bit_set( B_E ); 
	delay_500ns();
	graphic_ctrl_bit_clear( B_E ); 
	
	if( controller & B_CS1 )
	{
		select_controller( B_CS1);
		graphic_wait_ready();
	}
	if( controller & B_CS2 )
	{
		select_controller( B_CS2);
		graphic_wait_ready();
	}
	
	*portOdrHigh = 0;
	graphic_ctrl_bit_set( B_E ); 
	select_controller( 0 );
}




static unsigned char  graphic_read(unsigned char controller)
{
	display_read(controller);
	return display_read(controller);
}



static void graphic_writeCommand(unsigned char commandToWrite, unsigned char controller)
{
	graphic_ctrl_bit_clear( B_E ); 
	graphic_ctrl_bit_clear( B_DI | B_RW ); 
	graphic_write(commandToWrite, controller);
}


static void graphic_writeData(unsigned char data, unsigned char controller)
{
	graphic_ctrl_bit_clear( B_E ); 
	graphic_ctrl_bit_set( B_DI ); 
	graphic_ctrl_bit_clear( B_RW ); 
	graphic_write(data, controller);
}



void graphic_clearScreen(void)
{
	unsigned char i, j;
	for(j = 0; j < 8; j++)
	{
		graphic_writeCommand(LCD_SET_PAGE | j, B_CS1|B_CS2 );
		graphic_writeCommand(LCD_SET_ADD | 0, B_CS1|B_CS2 );
		for(i = 0; i <= 63; i++){
			graphic_writeData(0,  B_CS1|B_CS2);
		}
  }
}



void pixel( int x, int y, int set )
{
	unsigned char mask,c, controller;
	int	index;
	
	if( (x > 127 ) || (y > 63) )
	return;
	
	index = y/8;
	switch( y%8 )
	{
		case 0: mask = 1; break;
		case 1: mask = 2; break;
		case 2: mask = 4; break;
		case 3: mask = 8; break;
		case 4: mask = 0x10; break;
		case 5: mask = 0x20; break;
		case 6: mask = 0x40; break;
		case 7: mask = 0x80; break;
		default:
			mask = 0xAA;
	}
	if( set == 0)
		mask = ~mask;
		

	if(x >= 64){
		controller = B_CS2;
		x = x - 64;
	}else
		controller = B_CS1;
		
	graphic_writeCommand(LCD_SET_ADD | x, controller );
	graphic_writeCommand(LCD_SET_PAGE | index, controller );
	c = graphic_read( controller );
	graphic_writeCommand(LCD_SET_ADD | x, controller );
	if( set )
		mask = mask | c;
	else
		mask = mask & c;
	graphic_writeData( mask, controller);
}


void graphic_initalize(void)
{
	graphic_ctrl_bit_set( B_E ); 
	delay_micro(10);

	graphic_ctrl_bit_clear(B_CS1|B_CS2|B_RST|B_E);  
	delay_milli( 30 );
	graphic_ctrl_bit_set(B_RST); 	
	delay_milli( 100 );
	graphic_writeCommand(LCD_OFF, B_CS1|B_CS2);
	graphic_writeCommand(LCD_ON, B_CS1|B_CS2);
	graphic_writeCommand(LCD_DISP_START, B_CS1|B_CS2);
	graphic_writeCommand(LCD_SET_ADD, B_CS1|B_CS2);
	graphic_writeCommand(LCD_SET_PAGE, B_CS1|B_CS2);
	select_controller(0);
}


void	init_app(void)
{
	/* PORT E */
	*portModer	 	= 0x55555555;	/* all bits outputs */
	*portOtyper 	= 0x00000000;	/* outputs are push/pull */	
	*portOspeedr 	= 0x55555555;	/* medium speed */
	*portPupdr 		= 0x55550000;	/* inputs are pull up */
}




typedef struct tObj{
	int type;
	int	valid;
	int	sizex;
	int	sizey;
	int	dirx,diry;
	unsigned char	x,y;
	
} OBJECT, *POBJECT;

static OBJECT	objects[10];


int	create_object( int object, int type, unsigned char cx, unsigned char cy )
{
	objects[object].type = type;
	objects[object].dirx = 0;
	objects[object].diry = 0;

	objects[object].sizex = 4;
	objects[object].sizey = 4;

	
	objects[object].x = cx;
	objects[object].y = cy;
	
	objects[object].valid = 1;
	
	return 1;	/* Ok created object... */
}

void draw_object(int object)
{
	int 	x,y;
	if( ! objects[object].valid )
		return;
	x = objects[object].x;
	y = objects[object].y;

	pixel( x,y+1,1);
	pixel( x,y+2,1);

	pixel( x+1,y,1);
	pixel( x+1,y+1,1);
	pixel( x+1,y+2,1);
	pixel( x+1,y+3,1);

	pixel( x+2,y,1);
	pixel( x+2,y+1,1);
	pixel( x+2,y+2,1);
	pixel( x+2,y+3,1);

	pixel( x+3,y+1,1);
	pixel( x+3,y+2,1);
}


void clear_object(int object)
{
	int 	x,y;
	if( ! objects[object].valid )
		return;
	x = objects[object].x;
	y = objects[object].y;

	pixel( x,y+1,0);
	pixel( x,y+2,0);

	pixel( x+1,y,0);
	pixel( x+1,y+1,0);
	pixel( x+1,y+2,0);
	pixel( x+1,y+3,0);

	pixel( x+2,y,0);
	pixel( x+2,y+1,0);
	pixel( x+2,y+2,0);
	pixel( x+2,y+3,0);

	pixel( x+3,y+1,0);
	pixel( x+3,y+2,0);
}



int	set_object_direction( int object, int x, int y)
{ 
	if( ! objects[object].valid )
		return 0;
	objects[object].dirx = x;
	objects[object].diry = y;	
	return 1;	
}


void	auto_move_object(int object)
{
	/* move object in direction */
	int cx, cy;
	
	if( ! objects[object].valid )
		return;

	clear_object(object);	/* rubout current object */

	cx = (int) objects[object].x + objects[object].dirx;
	cy = (int) objects[object].y + objects[object].diry;

	/* should object bounce?  */
	if( cx+objects[object].sizex > 128) 
	{
		objects[object].dirx = - objects[object].dirx;
		cx = 128-objects[object].sizex;
	} 
	else if( cx<0 )
	{
		objects[object].dirx = - objects[object].dirx;
		cx = 0;
	}
	
	if( cy+objects[object].sizey > 64) 
	{
		objects[object].diry = - objects[object].diry;
		cy = 64 - objects[object].sizey;
	} 
	else if( cy<0 )
	{
		objects[object].diry = - objects[object].diry;
		cy = 0;
	}		
	/* save new position */
	objects[object].x = (unsigned char) cx;
	objects[object].y = (unsigned char) cy;
	draw_object(object);
}





int main(int argc, char **argv)
{
	init_app();	
	graphic_initalize();
#ifndef	SIMULATOR
	graphic_clearScreen();
#endif
	
	create_object(0,0,1,1);
	set_object_direction(0, 8, 1);
	
	while( 1 )
	{
		auto_move_object(0);
		delay_milli(40);	/* 25 frames/sec */
	}

	return 0;
}
