/*
 * 	Lab3_2.c
 *  "draw_rect"
 */

#define	SIMULATOR
//#define	USBDM

__attribute__((naked)) 
__attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		
__asm__ volatile(" MOV SP,R0\n");		
__asm__ volatile(" BL main\n");		
__asm__ volatile(" B .\n");		
}

#define		STK_CTRL 	((volatile unsigned int *)(0xE000E010))  
#define		STK_LOAD 	((volatile unsigned int *)(0xE000E014))  
#define		STK_VAL 	((volatile unsigned int *)(0xE000E018))  

/* FRÅN LAB 2.2 */
void delay_250ns( void )
{
	/* SystemCoreClock = 168000000 */
	*STK_CTRL = 0;
	*STK_LOAD = ( (168/4) -1 );
	*STK_VAL = 0;
	*STK_CTRL = 5;
	while( (*STK_CTRL & 0x10000 )== 0 );
	*STK_CTRL = 0;
}


void	delay_micro(unsigned int us)
{
	while( us > 0 )
	{
		delay_250ns();
		delay_250ns();
		delay_250ns();
		delay_250ns();
		us--;
	}
}

void	delay_milli(unsigned int ms)
{
	while( ms > 0 )
	{
#ifdef	SIMULATOR
		delay_micro( 1 );
#else
		delay_micro( 1000 );
#endif
		ms--;
	}
}

/* Graphic display */
__attribute__((naked)) 
void graphic_initalize(void)
{
	__asm volatile (" .HWORD	0xDFF0\n");	
	__asm volatile (" BX LR\n");		
}
 
__attribute__((naked)) 
void graphic_clear_screen(void)
{
    __asm volatile (" .HWORD	0xDFF1\n");		
	__asm volatile (" BX LR\n");		
}
 
__attribute__((naked))
void graphic_pixel_set( int x, int y)
{
    __asm volatile (" .HWORD	0xDFF2\n");		
	__asm volatile (" BX LR\n");		
}
 
__attribute__((naked))
void graphic_pixel_clear( int x, int y)
{
    __asm volatile (" .HWORD	0xDFF3\n");		
	__asm volatile (" BX LR\n");		
}
  

void	init_app(void)
{
#ifdef USBDM	
	/* starta klockor port D och E */
	* ( (unsigned long *) 0x40023830) = 0x18;
	__asm( 	" BL =0x08000209\n");
#endif	
}

typedef struct point
{
	char x,y;
} POINT, *PPOINT;


typedef struct line
{
    POINT   p0;
    POINT   p1;
} LINE, *PLINE;


int abs ( int i )
{
	if( i < 0 ) return -i;
	return i;
}

void swapint( int *a, int *b)
{
	int t = *a;
	*a = *b;
	*b = t;
}

int draw_line( PLINE l )
{
	int x0,x1,y0,y1,steep,deltax,deltay,error,ystep,x,y;
	
	/* Logiska koordinater */
	x0 = l->p0.x;
	x1 = l->p1.x;
	y0 = l->p0.y;
	y1 = l->p1.y;
	
    /* Sanitetskontroll.. */
	if( (x0 < 1)||(x0 > 128) )
		return 0;
	if( (y0 < 1)||(y0 > 64) )
		return 0;
	if( (x1 < 1)||(x1 > 128) )
		return 0;
	if( (y1 < 1)||(y1 > 64) )
		return 0;
 
	steep = abs (y1-y0) > abs (x1-x0);
	if( steep )
	{
		swapint( &x0, &y0 );
		swapint( &x1, &y1 );
	}
	if( x0 > x1 )
	{
		swapint( &x0, &x1 );
		swapint( &y0, &y1 );
	}
	
	deltax = x1-x0;
	deltay = abs( y1-y0 );
	error = 0;
	y = y0;
	if( y0 < y1 )ystep = 1;
	else ystep = -1;
	
	for ( x = x0; x <= x1 ;x++)
	{
		if( steep ) graphic_pixel_set( y, x);
		else graphic_pixel_set( x, y);
		error = error + deltay;
		if ( (error<<1) >= deltax)
		{
			y += ystep;
			error -= deltax;
		}
		
	}
}

typedef struct rect
{
    POINT   p;
    int x,y;
} RECT, *PRECT;


int draw_rect( PRECT r )
{	/* Kolla storlek > 0 */
	LINE l;
	l.p0.x = r->p.x;
	l.p0.y = r->p.y;
	l.p1.x = r->p.x+r->x;
	l.p1.y = r->p.y;
	if( ! draw_line( &l )) return 0;
	l.p0.x = l.p1.x;
	l.p0.y = l.p1.y;
	l.p1.y = r->p.y+r->y;
	if( ! draw_line( &l )) return 0;
	l.p0.x = l.p1.x;
	l.p0.y = l.p1.y;
	l.p1.x = r->p.x;
	if( ! draw_line( &l )) return 0;
	l.p0.x = l.p1.x;
	l.p0.y = l.p1.y;
	l.p1.y = r->p.y;
	if( ! draw_line( &l )) return 0;
	return 1;
}




RECT rectangles[]={
{10,10, 20,10},
{25,25, 10,20},
{40,30, 70,20},
{60,35, 10,10},
{70,10, 5,5},
};

void main(void)
{
	graphic_initalize();
	graphic_clear_screen();
 
	while( 1 )
	{
		for( int i = 0; i< sizeof(rectangles)/sizeof( RECT ); i++)
		{
			draw_rect( &rectangles[i] );
			delay_milli( 500 );
		}
		graphic_clear_screen();
	}
}

