/*
 * Lab4_1.c
 * SysTick med IRQ
 * Bargraph till port D0-D7
  */
 
#define	SIMULATOR
// #define USBDM

__attribute__((naked)) 
__attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		
__asm__ volatile(" MOV SP,R0\n");		
__asm__ volatile(" BL main\n");		
__asm__ volatile(" B .\n");		
}

#define		SysTickCtrl 	((volatile unsigned int *)(0xE000E010))  
#define		SysTickLoad 	((volatile unsigned int *)(0xE000E014))  
#define		SysTickVal 		((volatile unsigned int *)(0xE000E018))  


static volatile unsigned int	systick_flag, delay_count;


void	systick_irq_handler( void );

void delay_1mikro( void )
{
	systick_flag = 0;
	/* SystemCoreClock = 168000000 */
	*SysTickCtrl = 0;
	*SysTickLoad = ( 168-1 );
	*SysTickVal = 0;
	*SysTickCtrl = 7;
}


void	systick_irq_handler( void )
{
	*SysTickCtrl = 0;
	if (--delay_count > 0 )
		delay_1mikro();
	else
		systick_flag = 1;
}


#define		PORT_BARGRAPH_BASE	0x40020C00		/* MD407 port  */

#define		portBargraphModer 		((volatile unsigned int *)		(PORT_BARGRAPH_BASE))  
#define		portBargraphOtyper 		((volatile unsigned short *)	(PORT_BARGRAPH_BASE+0x4))  
#define		portBargraphOspeedr 	((volatile unsigned int *)		(PORT_BARGRAPH_BASE+0x8))  
#define		portBargraphOdrLow 		((volatile unsigned char *)		(PORT_BARGRAPH_BASE+0x14))  

void init_app( void )
{
#ifdef USBDM	
	/* starta klockor port D och E */
	* ( (unsigned long *) 0x40023830) = 0x18;
	/* initiera PLL */
	__asm volatile( " LDR R0,=0x08000209\n BLX R0 \n");
	/* Relokera vektortabellen */
	* ((unsigned long *)0xE000ED08) = 0x2001C000;
#endif	
	*( ( void (**)( void) ) 0x2001C03C ) = systick_irq_handler;
	/* PORT E */
	*portBargraphModer	 	= 0x00005555;	/* bits 0-7 are outputs */
	*portBargraphOtyper 	= 0x00000000;	/* outputs are push/pull */	
	*portBargraphOspeedr 	= 0x00005555;	/* medium speed */
}


#ifdef SIMULATOR
#define DELAY_COUNT 1000
#else
#define DELAY_COUNT	100000
#endif

void	delay( unsigned int count )
{
	delay_count = count;
	delay_1mikro();
}


void main(void)
{
	init_app();
	*portBargraphOdrLow = 0;
	delay( DELAY_COUNT );
	*portBargraphOdrLow = 0xFF;
	while(1)
	{
		if ( systick_flag )
			break;
	}
	*portBargraphOdrLow = 0;
}

