/*
 * 	Lab4_2.c
 *
 * Flank triggat avbrott med manuell återställning
 * Anslut IRQ Flip flop till Port E0-7
 * hexadecimal display till PD7-0
 */
 
 //#define USBDM
__attribute__((naked)) 
__attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		
__asm__ volatile(" MOV SP,R0\n");		
__asm__ volatile(" BL main\n");		
__asm__ volatile(" B .\n");		
}

#define SYSCFG_EXTICR1  0x40013808
#define EXTI_IMR        0x40013C00
#define EXTI_FTSR       0x40013C0C
#define EXTI_RTSR       0x40013C08
#define EXTI_PR         0x40013C14

#define EXTI3_IRQVEC    0x2001C064
#define	NVIC_ISER0 		0xE000E100  

#define NVIC_EXTI3_IRQ_BPOS  (1<<9)
#define EXTI3_IRQ_BPOS  (1<<3)

char count;

void irq_handler ( void )
{
	if(   *((unsigned int *) EXTI_PR) & EXTI3_IRQ_BPOS )
	{
        count++;
       *((unsigned int *) EXTI_PR) |= EXTI3_IRQ_BPOS;   /* Clear this interrupt */
 	}
}


void appInit ( void )
{
#ifdef USBDM	
	/* starta klockor port D och E */
	* ( (unsigned long *) 0x40023830) = 0x18;
	/* starta klockor för SYSCFG */
	* ((unsigned long *)0x40023844) |= 0x4000; 	
	/* Relokera vektortabellen */
	* ((unsigned long *)0xE000ED08) = 0x2001C000;
#endif	

  	* ( (unsigned long *) 0x40020C00) = 0x00005555; /* PD0-7, outports */
	count = 1;
    
   /* set PE3 as IRQ input, negative edge */
     *((unsigned int *) SYSCFG_EXTICR1) |= 0x4000;     /* PE3->EXTI3  */ 
    
    /* Configure the mask bit of the interrupt line (EXTI_IMR) */
    *((unsigned int *) EXTI_IMR) |= EXTI3_IRQ_BPOS; 
     
    /* Configure the Trigger selection bit of the interrupt line (EXTI_RTSR and EXTI_FTSR) */
    *((unsigned int *) EXTI_RTSR) |= EXTI3_IRQ_BPOS;		/* enable trigger on rising edge */ 
	*((unsigned int *) EXTI_FTSR) &= ~EXTI3_IRQ_BPOS;		/* disable trigger on falling edge */ 

    /* set the interrupt vector */
    *((void (**)(void) ) EXTI3_IRQVEC ) = irq_handler;

   
    /*  Configure the enable and mask bits that control the NVIC IRQ channel mapped to the
        external interrupt controller (EXTI) . */
    *((unsigned int *) NVIC_ISER0) |= NVIC_EXTI3_IRQ_BPOS;	/* Enable this interrupt */           
 }

void main(void)
{
    appInit();
	while(1){
        * ( (unsigned char *) 0x40020C14) = count;
	}
 }

