/*
 * 	Lab4_3.c
 *
 * Flank triggat avbrott med programstyrd återställning
 * Anslut IRQ Flip flop till Port E0-7
 * hexadecimal display till PD7-0
 */
 
//#define USBDM
__attribute__((naked)) 
__attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		
__asm__ volatile(" MOV SP,R0\n");		
__asm__ volatile(" BL main\n");		
__asm__ volatile(" B .\n");		
}


//#define SYSCFG_BASE     0x40013800
#define SYSCFG_EXTICR1  0x40013808
#define RCC_APB2ENR     0x40023844

//#define EXTI_BASE       0x40013C00
#define EXTI_IMR        0x40013C00
//#define EXTI_EMR        0x40013C04
#define EXTI_FTSR       0x40013C0C
#define EXTI_RTSR       0x40013C08
#define EXTI_PR         0x40013C14

//#define NVIC_BASE       0xE000E010
#define EXTI3_IRQVEC    0x2001C064
#define	NVIC_ISER0 		0xE000E100  
//#define	NVIC_ICER0 		0xE000E180  
//#define	NVIC_ISPR0 		0xE000E200  
//#define	NVIC_ICPR0 		0xE000E280  
//#define	NVIC_IABR0 		0xE000E300  
//#define	NVIC_IPR0       0xE000E400

#define NVIC_EXTI3_IRQ_BPOS  (1<<9)
#define EXTI3_IRQ_BPOS  (1<<3)


#define		PORT_BARGRAPH_BASE	0x40020C00		/* MD407 port D */
#define		PORT_FLIPFLOP_BASE	0x40021000		/* MD407 port E */

/* Flipflop */
#define		portFlipflopModer 	((volatile unsigned int *)	(PORT_FLIPFLOP_BASE))  
#define		portFlipflopOtyper 	((volatile unsigned short *)(PORT_FLIPFLOP_BASE+0x4))  
#define		portFlipflopOspeedr 	((volatile unsigned int *)	(PORT_FLIPFLOP_BASE+0x8))  
#define		portFlipflopPupdr 	((volatile unsigned int *)	(PORT_FLIPFLOP_BASE+0xC))  
#define		portFlipflopIdrLow 		((volatile unsigned char *)(PORT_FLIPFLOP_BASE+0x10))  
#define		portFlipflopOdrLow 	((volatile unsigned char *)	(PORT_FLIPFLOP_BASE+0x14))  
	
/* Bargraph */
#define		portBargraphModer 		((volatile unsigned int *)		(PORT_BARGRAPH_BASE))  
#define		portBargraphOtyper 		((volatile unsigned short *)	(PORT_BARGRAPH_BASE+0x4))  
#define		portBargraphOspeedr 	((volatile unsigned int *)		(PORT_BARGRAPH_BASE+0x8))  
#define		portBargraphOdrLow 		((volatile unsigned char *)		(PORT_BARGRAPH_BASE+0x14))  



char count;

void irq_handler ( void )
{
	unsigned char c = *portFlipflopIdrLow & 0xF;
	
	if(   *((unsigned int *) EXTI_PR) & EXTI3_IRQ_BPOS )
	{
		*((unsigned int *) EXTI_PR) |= EXTI3_IRQ_BPOS;   /* Clear this interrupt */
		if( c & 4 )
		{  /* IRQ2 */
			if( count )
				count = 0;
			else
				count = 0xFF;
				
			*portFlipflopOdrLow = 0x40;		/* acknowledge interrupts */   
		} else if ( c & 2 )
		{  /* IRQ1 */
			*portFlipflopOdrLow = 0x20;		/* acknowledge interrupts */   
			count = 0;
		}else if ( c & 1 )
		{  /* IRQ0 */
			*portFlipflopOdrLow = 0x10;		/* acknowledge interrupts */   
			count++;
		}
		*portFlipflopOdrLow = ~0x70;	/* reset acknowledge pulses */   
	}
}


void appInit ( void )
{
#ifdef USBDM	
	/* starta klockor port D och E, initiera PLL och relokera avbrottsvektorer */
	__asm volatile( " LDR R0,=0x08000209\n BLX R0 \n");
#endif	
	/*	PORT E
 	b7-b4 will be outputs
	b3-b0 will be inputs
	*/
	*portFlipflopModer = 		0x00005500;		/* Data direction digital io */	
	*portFlipflopPupdr = 		0x00000000;		/* Input, floating */
	*portFlipflopOspeedr = 		0x0000FF00;		/* Output, high speed */
	*portFlipflopOdrLow = 0;
	
	*portFlipflopIdrLow = 0;

	*portBargraphModer	 	= 0x00005555;	/* bits 0-7 are outputs */
	*portBargraphOtyper 	= 0x00000000;	/* outputs are push/pull */	
	*portBargraphOspeedr 	= 0x00005555;	/* medium speed */

 	count = 1;
	*portFlipflopOdrLow = 0x70;	
	*portFlipflopOdrLow = ~0x70;	/* reset acknowledge pulses */   

    
   /* set PE3 as IRQ input, negative edge */
 //   *((unsigned int *) RCC_APB2ENR) |= 0x4000;     /* Enable SYSCFG clock  */ 
    *((unsigned short *) SYSCFG_EXTICR1) |= 0x4000;     /* PE3->EXTI3  */ 
    // *((unsigned int *) SYSCFG_EXTICR1) |= 0x4000;     /* PE3->EXTI3 short/int fungerar... */ 
   
    /* Configure the mask bit of the interrupt line (EXTI_IMR) */
    *((unsigned int *) EXTI_IMR) |= EXTI3_IRQ_BPOS; 
     
    /* Configure the Trigger selection bit of the interrupt line (EXTI_RTSR and EXTI_FTSR) */
    *((unsigned int *) EXTI_RTSR) |= EXTI3_IRQ_BPOS;		/* enable trigger on falling edge */ 
	*((unsigned int *) EXTI_FTSR) &= ~EXTI3_IRQ_BPOS;		/* disable trigger on rising edge */ 

    /* set the interrupt vector */
    *((void (**)(void) ) EXTI3_IRQVEC ) = irq_handler;

   
    /*  Configure the enable and mask bits that control the NVIC IRQ channel mapped to the
        external interrupt controller (EXTI) . */
    *((unsigned int *) NVIC_ISER0) |= NVIC_EXTI3_IRQ_BPOS;	/* Enable this interrupt */           
 }

void main(void)
{
    appInit();
	while(1){
        * portBargraphOdrLow = count;
	}
 }

