/*
* libMD407.h
* Declaration of library functions, constants etc...
*/
#include <stdio.h>
#include <errno.h>
#include <sys/stat.h>
#include <unistd.h>

typedef struct
{
  char name[16];	
  int (*init) (int);
  void (*deinit) (int);
  int (*fstat)(struct stat *st);
  int (*isatty)(void);
  int (*open)(const char name,int flags,int mode);
  int (*close)(void);
  int (*lseek)(int ptr, int dir);
  int (*write)(char *ptr, int len);
  int (*read)(char *ptr, int len); 
} DEV_DRIVER_DESC, *PDEV_DRIVER_DESC;


/* Constants */



#define MAX_FILENO  4

/* Constant defined by linker */
extern char __heap_low; 
extern char __heap_top; 
extern char __bss_start; 
extern char __bss_end; 

/* File handle constants */
enum {STDIN=STDIN_FILENO,STDOUT=STDOUT_FILENO,STDERR=STDERR_FILENO,KEYPAD_FILENO,ASCIIDISPLAY_FILENO};


/* Library defined functions */
void crt_init( void );
void crt_deinit( void );

char *_sbrk(int);
int _isatty(int file);

