/*
 * delay.c
 * Bargraph ansluts till PD7-PD0
 * Kontroll av 500 ms fördröjning
 * Beroende på plattform kan anpassningen av fördröjning variera
 */

__attribute__((naked)) 
__attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		
__asm__ volatile(" MOV SP,R0\n");		
__asm__ volatile(" BL main\n");		
__asm__ volatile(" B .\n");		
}

/* ---------------------------------------------------- */
/* Port D */
#define		PORT_D_BASE		0x40020C00
#define		GPIO_D_MODER 	((volatile unsigned int *)	(PORT_D_BASE))  
#define		GPIO_D_OTYPER 	((volatile unsigned short *)(PORT_D_BASE+0x4))  
#define		GPIO_D_OSPEEDR 	((volatile unsigned int *)	(PORT_D_BASE+0x8))  
#define		GPIO_D_ODRLOW 	((volatile unsigned char *)	(PORT_D_BASE+0x14))  
/* SysTick */
#define		STK_CTRL 	((volatile unsigned int *)(0xE000E010))  
#define		STK_LOAD 	((volatile unsigned int *)(0xE000E014))  
#define		STK_VAL 	((volatile unsigned int *)(0xE000E018))  

void delay_250ns( void )
{
	/* SystemCoreClock = 168000000 */
	*STK_CTRL = 0;
	*STK_LOAD = ( (168/4) -1 );
	*STK_VAL = 0;
	*STK_CTRL = 5;
	while( (*STK_CTRL & 0x10000 )== 0 );
	*STK_CTRL = 0;
}

void	delay_micro(unsigned int us)
{
	while( us > 0 )
	{
		delay_250ns();
		delay_250ns();
		delay_250ns();
		delay_250ns();
		us--;
	}
}

void	delay_milli(unsigned int ms)
{
//#ifdef	SIMULATOR
// Denna anpassning kan variera beroende på plattform
	ms = ms / 1000;
	ms++;
//#endif
	while( ms > 0 )
	{
		delay_micro( 1000 );
		ms--;
	}
}

void init_app( void )
{
	/* PORT D */
	*GPIO_D_MODER	= 0x00005555;	/* bits 0-7 are outputs */
	*GPIO_D_OTYPER 	= 0x00000000;	/* outputs are push/pull */	
	*GPIO_D_OSPEEDR	= 0x00005555;	/* medium speed */
}

/* ---------------------------------------------------- */
void main(void)
{
	init_app();
	while(1)
	{
		*GPIO_D_ODRLOW = 0;
		*GPIO_D_ODRLOW = 0;
		delay_milli(500);
		*GPIO_D_ODRLOW = 0xFF;
		*GPIO_D_ODRLOW = 0xFF;
		delay_milli(500);
	}
}
