/*
 * 	polytest.c
 *  "draw_polygon"
 */

#define	SIMULATOR
//#define	USBDM

__attribute__((naked)) 
__attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		
__asm__ volatile(" MOV SP,R0\n");		
__asm__ volatile(" BL main\n");		
__asm__ volatile(" B .\n");		
}

#define		STK_CTRL 	((volatile unsigned int *)(0xE000E010))  
#define		STK_LOAD 	((volatile unsigned int *)(0xE000E014))  
#define		STK_VAL 	((volatile unsigned int *)(0xE000E018))  

/* FRÅN LAB 2.2 */
void delay_250ns( void )
{
	/* SystemCoreClock = 168000000 */
	*STK_CTRL = 0;
	*STK_LOAD = ( (168/4) -1 );
	*STK_VAL = 0;
	*STK_CTRL = 5;
	while( (*STK_CTRL & 0x10000 )== 0 );
	*STK_CTRL = 0;
}


void	delay_micro(unsigned int us)
{
	while( us > 0 )
	{
		delay_250ns();
		delay_250ns();
		delay_250ns();
		delay_250ns();
		us--;
	}
}

void	delay_milli(unsigned int ms)
{
	while( ms > 0 )
	{
#ifdef	SIMULATOR
		delay_micro( 1 );
#else
		delay_micro( 1000 );
#endif
		ms--;
	}
}

/* Graphic display */
__attribute__((naked)) 
void graphic_initalize(void)
{
	__asm volatile (" .HWORD	0xDFF0\n");	
	__asm volatile (" BX LR\n");		
}
 
__attribute__((naked)) 
void graphic_clear_screen(void)
{
    __asm volatile (" .HWORD	0xDFF1\n");		
	__asm volatile (" BX LR\n");		
}
 
__attribute__((naked))
void graphic_pixel_set( int x, int y)
{
    __asm volatile (" .HWORD	0xDFF2\n");		
	__asm volatile (" BX LR\n");		
}
 
__attribute__((naked))
void graphic_pixel_clear( int x, int y)
{
    __asm volatile (" .HWORD	0xDFF3\n");		
	__asm volatile (" BX LR\n");		
}
  

void	init_app(void)
{
#ifdef USBDM	
	/* starta klockor port D och E */
	* ( (unsigned long *) 0x40023830) = 0x18;
	__asm( 	" BL =0x08000209\n");
#endif	
}

typedef struct
{
	char x,y;
} POINT, *PPOINT;


typedef struct
{
    POINT   p0;
    POINT   p1;
} LINE, *PLINE;


int abs ( int i )
{
	if( i < 0 ) return -i;
	return i;
}

void swapint( int *a, int *b)
{
	int t = *a;
	*a = *b;
	*b = t;
}

int draw_line( PLINE l )
{
	int x0,x1,y0,y1,steep,deltax,deltay,error,ystep,x,y;
	
	/* Logiska koordinater */
	x0 = l->p0.x;
	x1 = l->p1.x;
	y0 = l->p0.y;
	y1 = l->p1.y;
	
    /* Sanitetskontroll.. */
	if( (x0 < 1)||(x0 > 128) )
		return 0;
	if( (y0 < 1)||(y0 > 64) )
		return 0;
	if( (x1 < 1)||(x1 > 128) )
		return 0;
	if( (y1 < 1)||(y1 > 64) )
		return 0;
 
	steep = abs (y1-y0) > abs (x1-x0);
	if( steep )
	{
		swapint( &x0, &y0 );
		swapint( &x1, &y1 );
	}
	if( x0 > x1 )
	{
		swapint( &x0, &x1 );
		swapint( &y0, &y1 );
	}
	
	deltax = x1-x0;
	deltay = abs( y1-y0 );
	error = 0;
	y = y0;
	if( y0 < y1 )ystep = 1;
	else ystep = -1;
	
	for ( x = x0; x <= x1 ;x++)
	{
		if( steep ) graphic_pixel_set( y, x);
		else graphic_pixel_set( x, y);
		error = error + deltay;
		if ( (error<<1) >= deltax)
		{
			y += ystep;
			error -= deltax;
		}
		
	}
}

typedef struct poly
{
    POINT   p;
    struct poly *next;
} POLY, *PPOLY;



int draw_polygon( PPOLY ptr )
{	
	LINE l;
	l.p0.x = ptr->p.x;
	l.p0.y = ptr->p.y;
	ptr = ptr->next;
	while( ptr != 0 )
	{
		l.p1.x = ptr->p.x;
		l.p1.y = ptr->p.y;
		draw_line( &l );
		l.p0.x = ptr->p.x;
		l.p0.y = ptr->p.y;
		ptr = ptr->next;
	}
	return 1;
}




POLY pg8 = { 20,20, 0};
POLY pg7 = { 20,55, &pg8};
POLY pg6 = { 70,60, &pg7};
POLY pg5 = { 80,35, &pg6};
POLY pg4 = { 100,25, &pg5};
POLY pg3 = { 90,10, &pg4};
POLY pg2 = { 40,10, &pg3};
POLY pg1 = { 20,20, &pg2};

#if 0
POLY pg6 = { 30,30, 0};
POLY pg5 = { 10,5, &pg6};
POLY pg4 = { 10,15, &pg5};
POLY pg3 = { 15,20, &pg4};
POLY pg2 = { 20,30, &pg3};
POLY pg1 = { 30,30, &pg2};
#endif

void main(void)
{
	init_app();	
	graphic_initalize();
	graphic_clear_screen();
 
	while( 1 )
	{
		draw_polygon( &pg1 );
		delay_milli( 500 );
		graphic_clear_screen();
		delay_milli( 500 );
	}
}


