/*
 * 	stopwatch.c
 * NOT_ Fungerar ej med 100Hz-avbrott
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

#define SYSCFG_BASE     ((volatile unsigned int *)	(0x40013800))
#define SYSCFG_EXTICR1  ((volatile unsigned int *)	(0x40013808))

#define EXTI_BASE       ((volatile unsigned int *)	(0x40013C00))
#define EXTI_IMR        ((volatile unsigned int *)	(0x40013C00))
#define EXTI_FTSR       ((volatile unsigned int *)	(0x40013C0C))
#define EXTI_RTSR       ((volatile unsigned int *)	(0x40013C08))
#define EXTI_PR         ((volatile unsigned int *)	(0x40013C14))

#define	NVIC_ISER0 		((volatile unsigned int *)	(0xE000E100))  
#define	NVIC_ICPR0 		((volatile unsigned int *)	(0xE000E280))  
#define	NVIC_IPR0       ((volatile unsigned int *)	(0xE000E400))

#define EXTI3_IRQVEC    0x2001C064
#define NVIC_EXTI3_IRQ_BPOS  (1<<9)
#define EXTI3_IRQ_BPOS  (1<<3)

/* Port E */
#define		PORT_E_BASE		0x40021000
#define		GPIO_E_MODER 	((volatile unsigned int *)	(PORT_E_BASE))  
#define		GPIO_E_OTYPER 	((volatile unsigned short *)(PORT_E_BASE+0x4))  
#define		GPIO_E_OSPEEDR 	((volatile unsigned int *)	(PORT_E_BASE+0x8))  
#define		GPIO_E_PUPDR 	((volatile unsigned int *)	(PORT_E_BASE+0xC))  
#define		GPIO_E_IDRLOW 	((volatile unsigned char *) (PORT_E_BASE+0x10))  
#define		GPIO_E_ODRLOW 	((volatile unsigned char *)	(PORT_E_BASE+0x14))  

/* Port D */
#define		PORT_D_BASE		0x40020C00
#define		GPIO_D_MODER 	((volatile unsigned int *)	(PORT_D_BASE))  
#define		GPIO_D_OTYPER 	((volatile unsigned short *)(PORT_D_BASE+0x4))  
#define		GPIO_D_OSPEEDR 	((volatile unsigned int *)	(PORT_D_BASE+0x8))  
#define		GPIO_D_PUPDR 	((volatile unsigned int *)	(PORT_D_BASE+0xC))  
#define		GPIO_D_IDRLOW 	((volatile unsigned char *)(PORT_D_BASE+0x10))  
#define		GPIO_D_IDRHIGH 	((volatile unsigned char *)(PORT_D_BASE+0x11))  
#define		GPIO_D_ODRLOW 	((volatile unsigned char *)	(PORT_D_BASE+0x14))  
#define		GPIO_D_ODRHIGH 	((volatile unsigned char *)	(PORT_D_BASE+0x15))  

struct {
	char	min;
	char	sec_mul10;
	char	sec;
	char	sec_div10;
}stoptime;

int overflow;
int	running;

void reset_watch( void )
{
	stoptime.min = 0;
	stoptime.sec_div10 = 0;
	stoptime.sec = 0;
	stoptime.sec_mul10 = 0;	
	overflow = 0;
}


void bump_watch( void )
{
	if( overflow ) return;
	if( ! running ) return;
	stoptime.sec_div10++;
	if( stoptime.sec_div10 == 10 )
	{
		stoptime.sec++;
		stoptime.sec_div10 = 0;
	}
	if( stoptime.sec == 10 )
	{
		stoptime.sec_mul10++;
		stoptime.sec = 0;
	}
	if( stoptime.sec_mul10 == 7 )
	{
        stoptime.min++;
		stoptime.sec_mul10 = 0;
	}
	if( stoptime.min == 10 )
	{
		overflow++;
	}
}


void irq_handler ( void )
{
	unsigned char c = *GPIO_E_IDRLOW & 0xF;
	
	if(   *EXTI_PR & EXTI3_IRQ_BPOS )
	{
 		if( c & 4 )
		{  
			bump_watch();
			*GPIO_E_ODRLOW = 0x40;   
		} else if ( c & 2 )
		{  
			*GPIO_E_ODRLOW = 0x20; 
			reset_watch();
		}else if ( c & 1 )
		{  
			*GPIO_E_ODRLOW = 0x10;  
			if( running ) running = 0;
			else running = 1;
		}
 		*GPIO_E_ODRLOW = ~0x70;   
	}
	*EXTI_PR |= EXTI3_IRQ_BPOS;
}



void init_app ( void )
{
	*GPIO_D_MODER = 0x55555555;		
    *GPIO_D_OTYPER= 0x00000000;
	*GPIO_D_ODRLOW = 0;
	*GPIO_D_ODRHIGH = 0;
	
	*GPIO_E_MODER = 0x00005500;		
	*GPIO_E_PUPDR = 0x00000000;		
    *GPIO_E_OTYPER= 0x00000000;
	*GPIO_E_ODRLOW = 0;
	
	running = 0;
	*GPIO_E_ODRLOW = 0x70;	
	*GPIO_E_ODRLOW = ~0x70;	

    *SYSCFG_EXTICR1 |= 0x4000;     /* PE3->EXTI3  */ 
    
    /* Configure the mask bit of the interrupt line (EXTI_IMR) */
    *EXTI_IMR |= EXTI3_IRQ_BPOS; 
     
    *EXTI_RTSR |= EXTI3_IRQ_BPOS;
	*EXTI_FTSR &= ~EXTI3_IRQ_BPOS; 

    *((void (**)(void) ) EXTI3_IRQVEC ) = irq_handler;
    *((unsigned int *) NVIC_ISER0) |= NVIC_EXTI3_IRQ_BPOS;        
 }

void main(void)
{
	init_app();
	reset_watch();
	while(1)
	{
		*GPIO_D_ODRLOW = (stoptime.sec<<4)|stoptime.sec_div10;
		*GPIO_D_ODRHIGH = (stoptime.min<<4)|stoptime.sec_mul10;
	}
}

