/*
* libmd407.h
* Declaration of library functions, constants etc...
*/
#ifndef LIBMD407_H
#define LIBMD407_H

#include <stdio.h>
#include <errno.h>
#include <sys/stat.h>
#include <unistd.h>

typedef struct
{
  char name[16];	
  int (*init) (int);
  void (*deinit) (int);
  int (*fstat)(struct stat *st);
  int (*isatty)(void);
  int (*open)(const char name,int flags,int mode);
  int (*close)(void);
  int (*lseek)(int ptr, int dir);
  int (*write)(char *ptr, int len);
  int (*read)(char *ptr, int len); 
} DEV_DRIVER_DESC, *PDEV_DRIVER_DESC;


/* Constants */
#define MAX_DEVICE  5

/* File handle constants */
enum {KEYPAD_FILENO=3,ASCIIDISPLAY_FILENO};


/* Constant defined by linker */
extern char __heap_low; 
extern char __heap_top; 
extern char __bss_start__; 
extern char __bss_end__; 

/* Library defined functions */
void crt_init( void );
void crt_deinit( void );

char *_sbrk(int);



#endif		/* LIBMD407_H */

