/*
 * 	md407.realloc.c
 *  includes: _crt_init, _crt_deinit, _sbrk for malloc-support.
 *  template functions for stdio: 
 */
#include	<errno.h>
#include 	<sys/stat.h>
#include	<stdio.h>
#include 	<stdlib.h>
  
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=__stack_top\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL _crt_init\n");			/* init C-runtime library */
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(" BL _crt_deinit\n");			/* deinit C-runtime library */
__asm__ volatile(" .globl _exit\n");
__asm__ volatile("_exit: B _exit\n");				/* never return */
}

static char *heap_end;

char * _sbrk(int incr) {
extern char __heap_low; /* Defined by the linker */
extern char __heap_top; /* Defined by the linker */
	char *prev_heap_end;
 	if (heap_end == 0) {
		heap_end = &__heap_low;
	}
	prev_heap_end = heap_end;
	if (heap_end + incr > &__heap_top) {		
		errno = ENOMEM;
			return (char *)-1;
	}
	heap_end += incr;
	return (char *) prev_heap_end;	
}

__attribute__ ( (used) )		/* Will be optimised away otherwise... */
volatile static void _crt_init() {
extern char __heap_low; /* Defined by the linker */
extern char __heap_top; /* Defined by the linker */
extern char __bss_start__; 	/* Defined by the linker */
extern char __bss_end__; 	/* Defined by the linker */
	 char *s;
	heap_end = 0;
	 s = &__bss_start__;
	 while( s < &__bss_end__ )
		 *s++ = 0;
	 s = &__heap_low;
	 while( s < &__heap_top )
		 *s++ = 0;
}

__attribute__ ( (used) )		/* Will be optimised away otherwise... */
volatile static void _crt_deinit() {
}

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
int main(void)
{
  char str1[]="Beginning of string";
  char str2[]=", continuation of string";
  char *s1,*s2;
  s1 = malloc( strlen(str1)+1 );
  if( s1 == 0 ) exit(-1);
  strcpy( s1, str1 );
  s2 = realloc( s1, strlen(str1)+1 + strlen(str2)+1 );
  if( s2 == 0 ) exit(-1);
  strcat( s2,str2 );
  free( s2 );
}
