/*
 * 	priorities.c
 *
 */
void startup(void) __attribute__((naked)) __attribute__((section (".start_section")) );

void startup ( void )
{
__asm volatile(
	" LDR R0,=0x2001C000\n"		/* set stack */
	" MOV SP,R0\n"
	" BL main\n"				/* call main */
	"_exit: B .\n"				/* never return */
	) ;
}


#define		PORT_D_BASE		0x40020C00
#define		GPIO_D_MODER 	((volatile unsigned int *)	(PORT_D_BASE))  
#define		GPIO_D_OTYPER 	((volatile unsigned short *)(PORT_D_BASE+0x4))  
#define		GPIO_D_ODRLOW 	((volatile unsigned char *)	(PORT_D_BASE+0x14))  



static void	out7seg( unsigned char c )
{
static unsigned char segCode[]={ 
	0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,
	0x7F,0x67,0x77,0x7C,0x39,0x5E,0x79,0x71 };
	
	if( c > 15){
		*GPIO_D_ODRLOW = 0;
		return;
	}
	*GPIO_D_ODRLOW = segCode[c];
}

#define SCB_SHPR1 ((volatile unsigned int *) 0xE000ED18)
#define SCB_SHPR2 ((volatile unsigned int *) 0xE000ED1C)
#define SCB_SHPR3 ((volatile unsigned int *) 0xE000ED20)


#define SCB_ICSR (volatile unsigned int *) 0xE000ED04

#define BIT_SVC_PEND_SET (1<<28)
#define SET_SVC_IRQ_PENDING   (*SCB_ICSR |= BIT_SVC_PEND_SET)

#define BIT_SYSTICK_PEND_SET (1<<26)
#define SET_SYSTICK_IRQ_PENDING   (*SCB_ICSR |= BIT_SYSTICK_PEND_SET)

#define SET_SVC_PRIORITY(x)	 		(*SCB_SHPR3 = ((*SCB_SHPR3 & ~0x00F00000 ) | (x<<20) ))
#define SET_SYSTICK_PRIORITY(x)	 	(*SCB_SHPR3 = ((*SCB_SHPR3 & ~0xF0000000 ) | (x<<28) ))


void svc_irq_handler( void )
{
	out7seg( 1 );
	SET_SYSTICK_IRQ_PENDING;	/* fake SYSTICK interrupt */
	out7seg( 3 );

}

void systick_irq_handler( void )
{
	out7seg( 2 );

}

//#define USE_PRIORITIES
void main(void)
{
	*GPIO_D_MODER = 0x00005555;
    *GPIO_D_OTYPER= 0x00000000;
#ifdef USE_PRIORITIES
	SET_SVC_PRIORITY(0xF);
	SET_SYSTICK_PRIORITY(3);
#else
	SET_SVC_PRIORITY(0);
	SET_SYSTICK_PRIORITY(0);
#endif

	*((void (**)(void) ) 0x2001C038 ) = svc_irq_handler;
	*((void (**)(void) ) 0x2001C03C ) = systick_irq_handler;
	
	while( 1 )
	{
		out7seg( 0 );
		SET_SVC_IRQ_PENDING;
		out7seg( 4 );	
	}
}

