/*
 * 	pwmdemo.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

typedef unsigned char 	uint8_t;
typedef unsigned short 	uint16_t;
typedef unsigned long 	uint32_t;

/* RCC device */
typedef	struct	tagRccArmdevice {
	volatile uint32_t cr;		/* 0x00 */
	volatile uint32_t pllcfgr;	/* 0x04 */
	volatile uint32_t cfgr;	/* 0x08 */
	volatile uint32_t cir;	/* 0x0C */
	volatile uint32_t ahb1rstr;	/* 0x10 */
	volatile uint32_t ahb2rstr;	/* 0x14 */
	volatile uint32_t ahb3rstr;	/* 0x18 */
	volatile uint32_t reserved1; /* 0x1C */
	volatile uint32_t apb1rstr;	/* 0x20 */
	volatile uint32_t apb2rstr;	/* 0x24 */
	volatile uint32_t reserved2; /* 0x28 */
	volatile uint32_t reserved3; /* 0x2C */	
	volatile uint32_t ahb1enr;	/* 0x30 */
	volatile uint32_t ahb2enr;	/* 0x34 */
	volatile uint32_t ahb3enr;	/* 0x38 */
	volatile uint32_t reserved4; /* 0x3C */		
	volatile uint32_t apb1enr;	/* 0x40 */
	volatile uint32_t apb2enr;	/* 0x44 */
	volatile uint32_t reserved5; /* 0x48 */
	volatile uint32_t reserved6; /* 0x4C */	
	volatile uint32_t ahb1lpenr;	/* 0x50 */
	volatile uint32_t ahb2lpenr;	/* 0x54 */
	volatile uint32_t ahb3lpenr;	/* 0x58 */
	volatile uint32_t reserved7; /* 0x5C */	
	volatile uint32_t apb1lpenr;	/* 0x60 */
	volatile uint32_t apb2lpenr;	/* 0x64 */
	volatile uint32_t reserved8; /* 0x68 */
	volatile uint32_t reserved9; /* 0x6C */	
	volatile uint32_t bdcr;		/* 0x70 */
	volatile uint32_t csr;		/* 0x74 */
	volatile uint32_t reserved10; /* 0x78 */
	volatile uint32_t reserved11; /* 0x7C */	
	volatile uint32_t sscgr;		/* 0x80 */
	volatile uint32_t plli2scfgr;	/* 0x84 */
} RCC_ARM_DEVICE, *PRCC_ARM_DEVICE;
#define		RCC		((volatile PRCC_ARM_DEVICE) 0x40023800)

/* ARM GPIO device */
typedef	struct	tagGpiodevice{
	volatile uint32_t	moder;	/* 0x00 */
	volatile uint32_t	otyper;	/* 0x04 */
	volatile uint32_t	ospeedr;	/* 0x08 */
	volatile uint32_t	pupdr;	/* 0x0C */
	volatile uint32_t	idr;	/* 0x10 */
	volatile uint32_t	odr;	/* 0x14 */
	volatile uint16_t	bsrl;	/* 0x18 */
	volatile uint16_t	bsrh;	/* 0x1C */
	volatile uint32_t	lckr;	/* 0x20 */
	volatile uint32_t	afrl;	/* 0x24 */
	volatile uint32_t	afrh;	/* 0x28 */
} GPIO_DEVICE, *PGPIO_DEVICE;
#define		GPIOD	((volatile PGPIO_DEVICE) 0x40020C00)

typedef struct tagTimDevice
{
  volatile uint16_t cr1;         /* TIM control register 1,              Address offset: 0x00 */
  uint16_t res0;
  volatile uint16_t cr2;         /* TIM control register 2,              Address offset: 0x04 */
  uint16_t res1;
  volatile uint16_t smcr;        /* TIM slave mode control register,     Address offset: 0x08 */
  uint16_t res2;
  volatile uint16_t dier;        /* TIM DMA/interrupt enable register,   Address offset: 0x0C */
  uint16_t res3;
  volatile uint16_t sr;          /* TIM status register,                 Address offset: 0x10 */
  uint16_t res4;
  volatile uint16_t egr;         /* TIM event generation register,       Address offset: 0x14 */
  uint16_t res5;
  volatile uint16_t ccmr1;       /* TIM capture/compare mode register 1, Address offset: 0x18 */
  uint16_t res6;
  volatile uint16_t ccmr2;       /* TIM capture/compare mode register 2, Address offset: 0x1C */
  uint16_t res7;
  volatile uint16_t ccer;        /* TIM capture/compare enable register, Address offset: 0x20 */
  uint16_t res8;
  volatile uint32_t cnt;         /* TIM counter register,                Address offset: 0x24 */
  volatile uint16_t psc;         /* TIM prescaler,                       Address offset: 0x28 */
  uint16_t res9;
  volatile uint32_t arr;         /* TIM auto-reload register,            Address offset: 0x2C */
  volatile uint16_t rcr;         /* TIM repetition counter register,     Address offset: 0x30 */
  uint16_t res10;
  volatile uint32_t ccr1;        /* TIM capture/compare register 1,      Address offset: 0x34 */
  volatile uint32_t ccr2;        /* TIM capture/compare register 2,      Address offset: 0x38 */
  volatile uint32_t ccr3;        /* TIM capture/compare register 3,      Address offset: 0x3C */
  volatile uint32_t ccr4;        /* TIM capture/compare register 4,      Address offset: 0x40 */
  volatile uint16_t bdtr;        /* TIM break and dead-time register,    Address offset: 0x44 */
  uint16_t res11;
  volatile uint16_t dcr;         /* TIM DMA control register,            Address offset: 0x48 */
  uint16_t res12;
  volatile uint16_t dmar;        /* TIM DMA address for full transfer,   Address offset: 0x4C */
  uint16_t res13;
  volatile uint16_t or;          /* TIM option register,                 Address offset: 0x50 */
  uint16_t res14;
} TIM_ARM_DEVICE, *PTIM_ARM_DEVICE;
#define TIM4 ((PTIM_ARM_DEVICE) 0x40000800)

#define		STK_CTRL 	((volatile unsigned int *)(0xE000E010))  
#define		STK_LOAD 	((volatile unsigned int *)(0xE000E014))  
#define		STK_VAL 	((volatile unsigned int *)(0xE000E018))  


void delay_1000us( void )
{
	/* SystemCoreClock = 168000000 */
	*STK_CTRL = 0;
	*STK_LOAD = ( (168000) -1 );
	*STK_VAL = 0;
	*STK_CTRL = 5;
	while( (*STK_CTRL & 0x10000 )== 0 );
	*STK_CTRL = 0;
}

void delay_ms( int ms )
{
	while( ms-- )
		delay_1000us();
}


void init_app( void )
{
  RCC->apb1enr |= (1<<2); /* Aktivera klocka för TIM4 */
  RCC->apb1rstr |= (1<<2); /* Återställ TIM4 */
  RCC->apb1rstr &= ~(1<<2); 

 /* Använd AF och koppla utgång från TIM4 till PD12 */
  GPIOD->moder |= 0x56550000;	/* Pin 12 är AF, övriga PD8-15 digital ut */
  GPIOD->ospeedr |= 0x02000000;	/* 50 MHz */
  GPIOD->afrh |= 0x20000;       /* Anslut TIM4 till AF */	
}


void setPWM( int period, int duty )
{
  TIM4->cr1 = 0; /* Räknare, mod etc.  */
  TIM4->arr = (unsigned short) period*2; /* Periodtid */
  TIM4->psc = 42000; /* Prescaler 0,5 ms periodtid */
  TIM4->cr1 = 0x81;  /* Aktivera TIM4 */
  TIM4->ccer &= ~1;  /* Avaktivera kanal 1 */
  TIM4->ccr1 = (unsigned short) duty*2;		
  TIM4->ccmr1 = 0x60; /* PWM1 mod */ 
  TIM4->ccer = 1; /* Aktivera kanalen */
}

int main()
{
  int i;
  
  init_app();
  while (1)
  {
	  for( i = 0; i <= 10; i++){
		setPWM( 10, i );
		delay_ms( 200 );
	  }
	  for( i = 9; i >= 0; i--){
		setPWM( 10, i );
		delay_ms( 200 );
	  }
	  delay_ms( 500 );
  }
}

int main2()
{
  init_app();
  setPWM( 1000, 700 );
}
