/*
 * 	startup.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}


#define SYSCFG_EXTICR2  ( ( volatile unsigned int *) 0x4001380C)
#define SYSCFG_EXTICR3  ( ( volatile unsigned int *) 0x40013810)
#define EXTI_IMR        ( ( volatile unsigned int *) 0x40013C00)
#define EXTI_FTSR       ( ( volatile unsigned int *) 0x40013C0C)
#define EXTI_RTSR       ( ( volatile unsigned int *) 0x40013C08)
#define EXTI_PR         ( ( volatile unsigned int *) 0x40013C14)

#define	NVIC_ISER0 		( ( volatile unsigned int *) 0xE000E100)  

#define NVIC_EXTI5_9_IRQ_BPOS  (1<<23)
#define EXTI5_IRQ_BPOS  (1<<5)
#define EXTI6_IRQ_BPOS  (1<<6)
#define EXTI7_IRQ_BPOS  (1<<7)
#define EXTI8_IRQ_BPOS  (1<<8)
#define EXTI5_9_IRQVEC    0x2001C09C


typedef	struct sCruiseControl{
	volatile unsigned char ctrl;
	volatile unsigned char sm;
	volatile unsigned char vel;
	volatile unsigned char ir;
}CRUISE_CONTROL;
#define	CRUISE_CONTROL_BASE	0xA00
#define CruiseC ((CRUISE_CONTROL *) CRUISE_CONTROL_BASE)

#define	INC		8
#define	DEC		4
#define	LOCK	2
#define	AUTO	1
#define	IREQ	8
#define	DREQ	4
#define	CROFF	2
#define	CRON	1

void irq_handler ( void );

void app_init(void)
{
	CruiseC->ctrl = 0;	
    *SYSCFG_EXTICR2 |= 0x4440;     
    *SYSCFG_EXTICR3 |= 0x0004;     
    *EXTI_IMR |= ( EXTI5_IRQ_BPOS|EXTI6_IRQ_BPOS|EXTI7_IRQ_BPOS|EXTI8_IRQ_BPOS ); 
	*EXTI_RTSR |= ( EXTI5_IRQ_BPOS|EXTI6_IRQ_BPOS|EXTI7_IRQ_BPOS|EXTI8_IRQ_BPOS ); 
	*EXTI_FTSR |= ( EXTI5_IRQ_BPOS|EXTI6_IRQ_BPOS|EXTI7_IRQ_BPOS|EXTI8_IRQ_BPOS ); 		 
    *((void (**)(void) ) EXTI5_9_IRQVEC ) = irq_handler;
    *NVIC_ISER0 |= NVIC_EXTI5_9_IRQ_BPOS;	        
}



void	irq_handler( void )
{
	/* prioritetsbaserad kontroll */
	if( CruiseC->ir & CROFF )
	{
		CruiseC->ctrl = 0;				/* återställ alla bitar */
		CruiseC->ir |= CROFF;			/* kvittera avbrott från port */
        *EXTI_PR |= EXTI5_IRQ_BPOS;     /* återställ avbrott i EXTI modul */
	}else if( CruiseC->ir & CRON )
	{
        CruiseC->ctrl = 0;				/* återställ alla bitar */
		CruiseC->sm = 0x55;			    /* aktiveringsalgoritm */
		CruiseC->sm = 0xAA;
		CruiseC->sm = 0x55;
		CruiseC->ctrl = AUTO;			/* aktivera farthållaren */
		CruiseC->ctrl = LOCK|AUTO;		/* lås hastigheten */
		CruiseC->ir |= CRON;			/* kvittera avbrott från port */
        *EXTI_PR |= EXTI6_IRQ_BPOS;     /* återställ avbrott i EXTI modul */
	}else if( CruiseC->ir & DREQ )
	{
		if( CruiseC->vel != 0 )
			CruiseC->ctrl = DEC|AUTO;	/* minska hastigheten */
		CruiseC->ir |= DREQ;			/* kvittera avbrott */
        *EXTI_PR |= EXTI7_IRQ_BPOS;     /* återställ avbrott i EXTI modul */
	}else if( CruiseC->ir & IREQ )
	{
		if( CruiseC->vel != 0xFF )
			CruiseC->ctrl = INC|AUTO;	/* öka hastigheten */
		CruiseC->ir |= IREQ;			/* kvittera avbrott */
        *EXTI_PR |= EXTI8_IRQ_BPOS;     /* återställ avbrott i EXTI modul */
	}	
}