/*
 * 	data_acc.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

#define SYSCFG_EXTICR1  ( ( volatile unsigned int *) 0x40013808)
#define EXTI_IMR        ( ( volatile unsigned int *) 0x40013C00)
#define EXTI_FTSR       ( ( volatile unsigned int *) 0x40013C0C)
#define EXTI_RTSR       ( ( volatile unsigned int *) 0x40013C08)
#define EXTI_PR         ( ( volatile unsigned int *) 0x40013C14)

#define	NVIC_ISER0 		( ( volatile unsigned int *) 0xE000E100)  

#define PORT_E_BASE			( ( volatile unsigned long *) 0x40021000)
#define PORT_E_INLOW		( ( volatile char *) 0x40021010)
#define PORT_E_INHIGH		( ( volatile char *) 0x40021011)
#define PORT_D_BASE			( ( volatile unsigned long *) 0x40020C00)
#define PORT_D_OUTLOW		( ( volatile char *) 0x40020C14)
#define PORT_D_OUTHIGH		( ( volatile char *) 0x40020C15)

#define NVIC_EXTI1_IRQ_BPOS  (1<<7)
#define EXTI1_IRQ_BPOS  (1<<1)
#define EXTI1_IRQVEC    0x2001C05C

void irq_handler ( void );

void app_init(void)
{

 	* PORT_D_BASE = 0x55555555; 
 	* PORT_E_BASE = 0; 

    *SYSCFG_EXTICR1 |= 0x0040;     
    *EXTI_IMR |= EXTI1_IRQ_BPOS; 
	*EXTI_RTSR |= EXTI1_IRQ_BPOS;		
	*EXTI_FTSR |= EXTI1_IRQ_BPOS;		 
    *((void (**)(void) ) EXTI1_IRQVEC ) = irq_handler;
    *NVIC_ISER0 |= NVIC_EXTI1_IRQ_BPOS;	        
}



void irq_handler ( void )
{
	if( *EXTI_PR & EXTI1_IRQ_BPOS )
	{
		if( *PORT_E_INLOW & 1 )
		{
			if( *PORT_E_INLOW & 2 )
				*PORT_D_OUTHIGH = *PORT_E_INHIGH;
			else
				*PORT_D_OUTLOW = *PORT_E_INHIGH;					
		}else{
			if( *PORT_E_INLOW & 2 )
				*PORT_D_OUTHIGH = 0xFF;
			else
				*PORT_D_OUTLOW = 0xFF;
		}
        *EXTI_PR |= EXTI1_IRQ_BPOS;   
 	}
}


void main(void)
{
	app_init();
	while(1);
}

