/*
 * 	exam-alu.c
 *  Dil in 
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");
__asm__ volatile(" B .\n");
__asm__ volatile(" .ltorg\n");
}

/* Port D */
#define		PORT_D_BASE		0x40020C00
#define		GPIO_D_MODER 	((volatile unsigned int *)	(PORT_D_BASE))  
#define		GPIO_D_OTYPER 	((volatile unsigned short *)(PORT_D_BASE+0x4))  
//#define		GPIO_D_OSPEEDR 	((volatile unsigned int *)	(PORT_D_BASE+0x8))  
#define		GPIO_D_PUPDR 	((volatile unsigned int *)	(PORT_D_BASE+0xC))  
#define		GPIO_D_IDRLOW 	((volatile unsigned char *)(PORT_D_BASE+0x10))  
//#define		GPIO_D_IDRHIGH 	((volatile unsigned char *)(PORT_D_BASE+0x11))  
//#define		GPIO_D_ODRLOW 	((volatile unsigned char *)	(PORT_D_BASE+0x14))  
//#define		GPIO_D_ODRHIGH 	((volatile unsigned char *)	(PORT_D_BASE+0x15))  

#define		GPIO_E_BASE		0x40021000		/* MD407 port E */
#define		GPIO_E_MODER 	((volatile unsigned int *)	(GPIO_E_BASE))  
#define		GPIO_E_OTYPER 	((volatile unsigned short *)(GPIO_E_BASE+0x4))  
//#define		GPIO_E_OSPEEDR 	((volatile unsigned int *)	(GPIO_E_BASE+0x8))  
#define		GPIO_E_PUPDR 	((volatile unsigned int *)	(GPIO_E_BASE+0xC))  
/* Byte address definitions */
#define		GPIO_E_IDRLOW 	((volatile unsigned char *)	(GPIO_E_BASE+0x10))  
//#define		GPIO_E_IDRHIGH 	((volatile unsigned char *)	(GPIO_E_BASE+0x10+1))  
//#define		GPIO_E_ODRLOW 	((volatile unsigned char *)	(GPIO_E_BASE+0x14))  
#define		GPIO_E_ODRHIGH 	((volatile unsigned char *)	(GPIO_E_BASE+0x14+1))  


#define SYSCFG_EXTICR1  ((volatile unsigned int *)	0x40013808)
#define EXTI_IMR        ((volatile unsigned int *)	0x40013C00)
#define EXTI_FTSR       ((volatile unsigned int *)	0x40013C0C)
#define EXTI_RTSR       ((volatile unsigned int *)	0x40013C08)
#define EXTI_PR         ((volatile unsigned int *)	0x40013C14)
#define EXTI3_IRQVEC    ((volatile unsigned int *)	0x2001C064)
#define	NVIC_ISER0 		((volatile unsigned int *)	0xE000E100 ) 

#define NVIC_EXTI3_IRQ_BPOS  (1<<9)
#define EXTI3_IRQ_BPOS  (1<<3)



char    evaluate( char x, char y, char f)
{
    switch( f )
    {
       case 0: return 0;
       case 1: return 0xF;
       case 2: return x;
       case 3: return y;
       case 4: return x+y;
       case 5: return x-y;
       case 6: return (x*y)&0xF;
       case 7: if( y == 0) return 0xF; else return x/y;
       case 8: if( y == 0) return 0; else return x%y;
       case 9: return x|y;
       case 10: return x&y;
       case 11: return x^y;
       case 12: return ((y<<1)|1) & 0xF;
       case 13: return (x<<1) & 0xF;;
       case 14: return (y>>1)|0x8;
       case 15: return x>>1;
   }
}

void irq_handler ( void )
{
    char x,y,f,u;
    x = *GPIO_D_IDRLOW & 0xF;
    y = *GPIO_D_IDRLOW >>4;
    f = *GPIO_E_IDRLOW >>4;
    u = evaluate(x,y,f);
    *GPIO_E_ODRHIGH = u;
    *((unsigned int *) EXTI_PR) |= EXTI3_IRQ_BPOS;
}

#define SYNCH

void    init_app( void )
{
	/*	PORT E
	b3  avbrott, synkron funktion på positiv flank
	b7-b4  funktionsvaljare (F)
	b11-b8 	utgång (U)
	*/
	*GPIO_E_MODER = 0x00550000;		
	*GPIO_E_PUPDR = 0x0000AA80;		/* Input, pull down */
    *GPIO_E_OTYPER= 0x00000000;	    /* outputs are push/pull */

	/* PORT D */
	*GPIO_D_MODER	= 0x00000000;	/* ingångar */
	*GPIO_D_PUPDR 	= 0xAAAAAAAA;	/* pull down */
  
#ifdef SYNCH  
    *SYSCFG_EXTICR1 |= 0x4000;     /* PE3->EXTI3  */ 
    *EXTI_IMR |= EXTI3_IRQ_BPOS; 
    *EXTI_RTSR |= EXTI3_IRQ_BPOS;		/* enable trigger on falling edge */ 
	*EXTI_FTSR &= ~EXTI3_IRQ_BPOS;		/* disable trigger on rising edge */ 
   *((void (**)(void) ) EXTI3_IRQVEC ) = irq_handler;
    *NVIC_ISER0 |= NVIC_EXTI3_IRQ_BPOS;	/* Enable this interrupt */           
#endif
}

void main(void)
{
    char x,y,f,u;
    init_app();   
    while( 1 )
    {
#ifdef  SYNCH
#else
        x = *GPIO_D_IDRLOW & 0xF;
        y = *GPIO_D_IDRLOW >>4;
        f = *GPIO_E_IDRLOW >>4;
        u = evaluate(x,y,f);
        *GPIO_E_ODRHIGH = u;
#endif
    }
}

