/*
 * 	exam-alu.c
 *  Dil in 
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");
__asm__ volatile(" B .\n");
__asm__ volatile(" .ltorg\n");
}
#define		GPIO_E_BASE		0x40021000		/* MD407 port E */
#define		GPIO_E_MODER 	((volatile unsigned int *)	(GPIO_E_BASE))  
#define		GPIO_E_OTYPER 	((volatile unsigned short *)(GPIO_E_BASE+0x4))  
#define		GPIO_E_PUPDR 	((volatile unsigned int *)	(GPIO_E_BASE+0xC))  
#define		GPIO_E_IDRLOW 	((volatile unsigned char *)	(GPIO_E_BASE+0x10))  
#define		GPIO_E_ODRHIGH 	((volatile unsigned char *)	(GPIO_E_BASE+0x14+1))  


#define SYSCFG_EXTICR1  ((volatile unsigned int *)	0x40013808)
#define EXTI_IMR        ((volatile unsigned int *)	0x40013C00)
#define EXTI_FTSR       ((volatile unsigned int *)	0x40013C0C)
#define EXTI_RTSR       ((volatile unsigned int *)	0x40013C08)
#define EXTI_PR         ((volatile unsigned int *)	0x40013C14)
#define	NVIC_ISER0 		((volatile unsigned int *)	0xE000E100 ) 

#define NVIC_EXTI1_IRQ_BPOS  (1<<7)
#define EXTI1_IRQ_BPOS  (1<<1)
#define NVIC_EXTI0_IRQ_BPOS  (1<<6)
#define EXTI0_IRQ_BPOS  (1<<0)

#define EXTI0_IRQVEC    ((volatile unsigned int *)	0x2001C058)
#define EXTI1_IRQVEC    ((volatile unsigned int *)	0x2001C05C)



char    evaluate( char a, char b, char s)
{
     switch( s )
    {
       case 0: return (a&&b);
       case 1: return (a||b);
       case 2: return !(a&&b);
       case 3: return !(a||b);
    }
}

void clk0_handler ( void )
{
    char a;
    a = *GPIO_E_IDRLOW & 0x10;
    if(a)
        *GPIO_E_ODRHIGH |= 2;
    else
        *GPIO_E_ODRHIGH &= ~2;
    *((unsigned int *) EXTI_PR) |= EXTI0_IRQ_BPOS;
}

void clk1_handler ( void )
{
    char b;
    b = *GPIO_E_IDRLOW & 0x20;
    if(b)
        *GPIO_E_ODRHIGH |= 2;
    else
        *GPIO_E_ODRHIGH &= ~2;
    *((unsigned int *) EXTI_PR) |= EXTI1_IRQ_BPOS;
}


void    init_app( void )
{
	/*	PORT E
	b3  avbrott, synkron funktion på positiv flank
	b7-b4  funktionsvaljare (F)
	b11-b8 	utgång (U)
	*/
	*GPIO_E_MODER = 0x00050000;		
	*GPIO_E_PUPDR = 0x00000AAA;		/* Input, pull down */
    *GPIO_E_OTYPER= 0x00000000;	    

    *SYSCFG_EXTICR1 |= 0x0044;     /* PE0->EXTI0, PE1->EXTI1 */ 
    *EXTI_IMR |= (EXTI1_IRQ_BPOS | EXTI0_IRQ_BPOS); 
   *((void (**)(void) ) EXTI0_IRQVEC ) = clk0_handler;
    *EXTI_RTSR &= EXTI0_IRQ_BPOS;		
	*EXTI_FTSR |= ~EXTI0_IRQ_BPOS;		
   *((void (**)(void) ) EXTI1_IRQVEC ) = clk1_handler;
    *EXTI_RTSR &= EXTI1_IRQ_BPOS;		
	*EXTI_FTSR |= ~EXTI1_IRQ_BPOS;		
   *NVIC_ISER0 |= (NVIC_EXTI1_IRQ_BPOS | NVIC_EXTI0_IRQ_BPOS);	           
}

void main(void)
{
    char a,b,s,u;
    init_app();   
    while( 1 )
    {
        a = *GPIO_E_IDRLOW & 0x10;
        b = *GPIO_E_IDRLOW & 0x20;
        s = (*GPIO_E_IDRLOW >>2) & 0x3;
        u = evaluate(a,b,s);
        if( u )
            *GPIO_E_ODRHIGH |= 1;
        else
            *GPIO_E_ODRHIGH &= ~1;
    }
}

