/*
 * 	exam-pulsetrain.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");	
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");	
__asm__ volatile(" B .\n");	
__asm__ volatile(".LTORG\n");	
}

typedef struct tag_usart
{
	volatile unsigned short sr;
	volatile unsigned short Unused0;
	volatile unsigned short dr;
	volatile unsigned short Unused1;
	volatile unsigned short brr;
	volatile unsigned short Unused2;
	volatile unsigned short cr1;
	volatile unsigned short Unused3;
	volatile unsigned short cr2;
	volatile unsigned short Unused4;
	volatile unsigned short cr3;
	volatile unsigned short Unused5;
	volatile unsigned short gtpr;
} USART;

#define USART1  ((USART *) 0x40011000)	

void	_outchar( char c )
{
 	while (( USART1->sr & (1<<7))==0);
	USART1->dr = (unsigned short) c;
}

char	_tstchar( void )
{
	if( (USART1->sr & (1<<5) )==0)
		return 0;
	return (char) USART1->dr;
}
	

char	_inchar( void )
{
	char c;
 	while ( (c=_tstchar() )==0);
	return c;	
}



int get_line(char * buffer)
{
	unsigned char  c ;
	int cursor_pos;
	cursor_pos = 0;
	do
	{
		c = _inchar();
		_outchar( c );
		switch( c )
		{
			case '\n': break; /* End appl */
			default:
				buffer[cursor_pos] = c;
				cursor_pos ++;
		}
	}while( c != '\n');
	return cursor_pos;
}



/* Timer 6 */
#define		TIM6_CR1 	((volatile unsigned short *)	0x40001000)  
#define		TIM6_DIER 	((volatile unsigned short *)	0x4000100C)  
#define		TIM6_SR 	((volatile unsigned short *)	0x40001010)  
#define		TIM6_PSC	((volatile unsigned short *)	0x40001028)  
#define		TIM6_ARR	((volatile unsigned short *)	0x4000102C)  

#define UIF		(1<<0)
#define UIE		(1<<0)
#define	CEN		(1<<0)

void delay_1ms( void )
{
	*TIM6_CR1 &= ~CEN;			/* Deaktivera räknaren */	 	 
	*TIM6_PSC= 83; 				/* Sätt tidbas till 1 ms */
	*TIM6_ARR = 999;
	*TIM6_DIER |= UIE;  		/* Tillåt UE */
	*TIM6_CR1 |= CEN; 			/* Aktivera räknaren */
	while(( *TIM6_SR & UIF ) == 0 );		/* Vänta tills UE */
	*TIM6_CR1 &= ~CEN;			/* Deaktivera räknaren */	 
}

void pulsetrain( char sequense[], int length )
{
	for( int i = 0; i < length; i++ )
	{
		if( sequense[i])
			_outchar('-' ) ;
		else
			_outchar('_') ;
		delay_1ms();
	}
}

/*
char test1[4] =  {1,0,1,0};
char test2[8] =  {1,0,0,1,1,1,0,1};
char test3[12] = {1,0,1,1,0,0,1,0,1,1,1,0};
 	pulsetrain( test1, 4 );
	_outchar('\n') ;
	pulsetrain( test2, 8 );
	_outchar('\n') ;
	pulsetrain( test3, 12 );
	_outchar('\n') ;
*/

void main(void)
{
	char buffer[32];
	char binbuffer[32];
	int length;
	
    while( 1 )
    {	/* Inmatningsformat 1010101 */
		length=get_line( buffer );
		for( int i = 0; i < length ; i++)
		{
			binbuffer[i] = buffer[i]-'0';
		}
		pulsetrain( binbuffer, length );
   }
}


