/*
 * 	exam-pwm.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");	
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");	
__asm__ volatile(" B .\n");	
__asm__ volatile(".LTORG\n");	
}

typedef struct tag_usart
{
	volatile unsigned short sr;
	volatile unsigned short Unused0;
	volatile unsigned short dr;
	volatile unsigned short Unused1;
	volatile unsigned short brr;
	volatile unsigned short Unused2;
	volatile unsigned short cr1;
	volatile unsigned short Unused3;
	volatile unsigned short cr2;
	volatile unsigned short Unused4;
	volatile unsigned short cr3;
	volatile unsigned short Unused5;
	volatile unsigned short gtpr;
} USART;

#define USART1  ((USART *) 0x40011000)	

void	_outchar( char c )
{
 	while (( USART1->sr & (1<<7))==0);
	USART1->dr = (unsigned short) c;
}

char	_tstchar( void )
{
	if( (USART1->sr & (1<<5) )==0)
		return 0;
	return (char) USART1->dr;
}
	

char	_inchar( void )
{
	char c;
 	while ( (c=_tstchar() )==0);
	return c;	
}



int get_line(char * buffer)
{
	unsigned char  c ;
	int cursor_pos;
	cursor_pos = 0;
	do
	{
		c = _inchar();
		_outchar( c );
		switch( c )
		{
			case '\n': break; /* End appl */
			default:
				buffer[cursor_pos] = c;
				cursor_pos ++;
		}
	}while( c != '\n');
	buffer[cursor_pos] = 0;
	return cursor_pos;
}



/* Timer 6 */
#define		TIM6_CR1 	((volatile unsigned short *)	0x40001000)  
#define		TIM6_DIER 	((volatile unsigned short *)	0x4000100C)  
#define		TIM6_SR 	((volatile unsigned short *)	0x40001010)  
#define		TIM6_PSC	((volatile unsigned short *)	0x40001028)  
#define		TIM6_ARR	((volatile unsigned short *)	0x4000102C)  

#define UIF		(1<<0)
#define UIE		(1<<0)
#define	CEN		(1<<0)

void delay_1ms( void )
{
	*TIM6_CR1 &= ~CEN;			/* Deaktivera räknaren */	 	 
	*TIM6_PSC= 83; 				/* Sätt tidbas till 1 ms */
	*TIM6_ARR = 999;
	*TIM6_DIER |= UIE;  		/* Tillåt UE */
	*TIM6_CR1 |= CEN; 			/* Aktivera räknaren */
	while(( *TIM6_SR & UIF ) == 0 );		/* Vänta tills UE */
	*TIM6_CR1 &= ~CEN;			/* Deaktivera räknaren */	 
}

void pwm( int dutycycle, int period, int repetitions)
{
	int noduty;
	while( repetitions > 0)
	{
		noduty = period - dutycycle;
		for( int i = 0; i < dutycycle; i++ )
		{
			_outchar('-' ) ;
			delay_1ms();
		}
		for( int i = 0; i < noduty; i++ )
		{
			_outchar('_') ;
			delay_1ms();
		}
		repetitions--;	
	}
}


void main(void)
{
	char buffer[32];
	int dutycycle, period, repetitions;
	
    unsigned int w,p;
    while( 1 )
    {	/* Inmatningsformat X,Y,Z */
		if( get_line( buffer ) == 5 )
		{
			dutycycle = buffer[0]-'0';
			period = buffer[2]-'0';
			repetitions = buffer[4]-'0';
			pwm( dutycycle, period, repetitions );
		}
   }
}

