/*
 * 	robot1.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}


/* i .h-fil */
typedef	volatile struct sROBOT{
    union{
        char ctrl;
        char RS:1,:2, EN:1,:2,IA:1,IE:1;
     };
     union{
        char status;
        char :2, ER:1, :1, IP:1;
    };
	unsigned short reserved;
	unsigned short dataY;
	unsigned short dataX;
	unsigned short posY;
	unsigned short posX;
}ROBOT;



/* i .c-fil */
void move(ROBOT *p, int x, int y )
{
  p->dataX = x;
  p->dataY = y;
  p->EN = 1;
	
  while( ( p->posX != x )||(p->posY != y ) ) ;
  p->EN = 0;		
}

void init(ROBOT *p)
{
  p->RS = 1;
  p->ctrl = 0;
  move( p,0,0 );
}

typedef struct point
{
	unsigned short x;
	unsigned short y;
	struct point * next;
} POINT;



POINT p4 = {36,39,0};
POINT p3 = {25,27,&p4};
POINT p2 = {12,14,&p3};
POINT p1 = {1,2,&p2};

void delayMS( unsigned int ms)
{}



void main(void)
{
    ROBOT *p = (ROBOT *) 0x100000;
    POINT *pt = &p1;
    unsigned short x,y;
    init( p );
    x = y = 0;
    while( pt != 0 )
    {
        move( p, pt->x, pt->y );
        if( pt->x > x) delayMS( pt->x - x );
        else if ( pt->x < x) delayMS( x - pt->x );
        x = pt->x;
        y = pt->y;
    }
}

