/*
 * 	startup.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

#define FC_RESET 	0x8
#define FC_RESTORE 	0x9
#define FC_SEEK 	0xA
#define FC_READ 	0xB
#define FC_WRITE 	0xC
#define FC_SEL0 	0xD
#define FC_SEL1 	0xE

typedef struct tag_fdc{
	unsigned char ctrl;
	unsigned char sec;
	unsigned char s_track;
	unsigned char stat;
	unsigned short addr_low;
	unsigned short addr_high;
} FDCDEV, *PFDCDEV;
#define FDC ((PFDCDEV) 0xF0000100 )

unsigned char buffer[512];

void FdcInit( void )
{
	FDC->ctrl = FC_RESET;
}

int FdcSelDrv( unsigned int drv )
{
	if ( drv > 1 )
		return;
	if( drv )
		FDC->ctrl = FC_SEL1;
	else
		FDC->ctrl = FC_SEL0;
	return (int) (FDC->stat & 0xf);		
}

int FdcReadSec( int side, int track, int sec, unsigned int add )
{
	FDC->s_track = (unsigned char) (side<<7 | track);
	FDC->ctrl = FC_SEEK;
	if( FDC->stat & 0x10 )
		return (FDC->stat & 0xf);
	FDC->sec = (unsigned char) sec;
	FDC->addr_low = (unsigned short) add;
	FDC->addr_high = (unsigned short) (add>>16);
	FDC->ctrl = FC_READ;
	return (int) (FDC->stat & 0xf);		
}

int FdcWriteSec( int side, int track, int sec, unsigned int add )
{
	FDC->s_track = (unsigned char) (side<<7 | track);
	FDC->ctrl = FC_SEEK;
	if( FDC->stat & 0x10 )
		return (FDC->stat & 0xf);
	FDC->sec = (unsigned char) sec;
	FDC->addr_low = (unsigned short) add;
	FDC->addr_high = (unsigned short) (add>>16);
	FDC->ctrl = FC_WRITE;
	return (int) (FDC->stat & 0xf);		
}



void main2(void)
{
	FdcInit();
	strcpy( buffer, "\nText string, to be written to disc...");
	if( FdcSelDrv(0) )
		return;
	if( FdcWriteSec( 0, 0, 0, (unsigned int) &buffer ) )
		return;
}



void main(void)
{
	FdcInit();
	if( FdcSelDrv(0) )
		return;
	if( FdcReadSec( 0, 5, 8, (unsigned int) &buffer ) )
		return;
	if( FdcSelDrv(1) )
		return;
	if( FdcWriteSec( 0, 0, 0, (unsigned int) &buffer ) )
		return;		
}

