/*
 * 	timer2_6oc.c
 *
 */
 
 #include <stdlib.h>
 
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

/* Port D */
#define		PORT_D_BASE		0x40020C00
#define		GPIO_D_MODER 	((volatile unsigned int *)	(PORT_D_BASE))  
#define		GPIO_D_OTYPER 	((volatile unsigned short *)(PORT_D_BASE+0x4))  
#define		GPIO_D_OSPEEDR 	((volatile unsigned int *)	(PORT_D_BASE+0x8))  
#define		GPIO_D_PUPDR 	((volatile unsigned int *)	(PORT_D_BASE+0xC))  
#define		GPIO_D_IDRLOW 	((volatile unsigned char *)(PORT_D_BASE+0x10))  
#define		GPIO_D_IDRHIGH 	((volatile unsigned char *)(PORT_D_BASE+0x11))  
#define		GPIO_D_ODRLOW 	((volatile unsigned char *)	(PORT_D_BASE+0x14))  
#define		GPIO_D_ODRHIGH 	((volatile unsigned char *)	(PORT_D_BASE+0x15))  

/* Reset and Clock Generator */
#define		RCC_APB1ENR 	((volatile unsigned int *)	0x40023840)  
#define		RCC_APB1RSTR 	((volatile unsigned int *)	0x40023820)  


/* Timer 5 */
#define		TIM5_CR1 	((volatile unsigned short *)	0x40000C00)  
#define		TIM5_CR2 	((volatile unsigned short *)	0x40000C04) 
#define		TIM5_SMCR 	((volatile unsigned short *)	0x40000C08)  
#define		TIM5_DIER 	((volatile unsigned short *)	0x40000C0C)  
#define		TIM5_SR 	((volatile unsigned short *)	0x40000C10)  
#define		TIM5_EGR 	((volatile unsigned short *)	0x40000C14) 
#define		TIM5_CCMR1 	((volatile unsigned short *)	0x40000C18) 
#define		TIM5_CCMR2 	((volatile unsigned short *)	0x40000C1C) 
#define		TIM5_CCERR 	((volatile unsigned short *)	0x40000C20) 
#define		TIM5_CNT 	((volatile unsigned int *)		0x40000C24)  
#define		TIM5_PSC	((volatile unsigned short *)	0x40000C28)  
#define		TIM5_ARR	((volatile unsigned int *)		0x40000C2C)  
#define		TIM5_CCR1	((volatile unsigned int *)		0x40000C34)  
#define		TIM5_CCR2	((volatile unsigned int *)		0x40000C38)  
#define		TIM5_CCR3	((volatile unsigned int *)		0x40000C3C)  
#define		TIM5_CCR4	((volatile unsigned int *)		0x40000C40)  
#define		TIM5_DCR	((volatile unsigned short *)	0x40000C48)  
#define		TIM5_DMAR	((volatile unsigned short *)	0x40000C4C)  
#define		TIM2_OR		((volatile unsigned short *)	0x40000C50)  
#define		TIM5_OR		((volatile unsigned short *)	0x40001050)  

#define NVIC_TIM5_IRQ_BPOS  (1<<18)
#define	NVIC_TIM5_ISER 		((volatile unsigned int *)	0xE000E104)  
#define	TIM5_IRQVEC 		((void (**)(void) ) 0x2001C108 ) 


#define UIF		(1<<0)
#define UG		(1<<0)
#define CC1G	(1<<1)
#define CC2G	(1<<2)
#define CC3G	(1<<3)
#define CC4G	(1<<4)
#define TG		(1<<6)


#define UIE		(1<<0)
#define CC1IE	(1<<1)
#define CC2IE	(1<<2)
#define CC3IE	(1<<3)
#define CC4IE	(1<<4)
#define TIE		(1<<6)




#define ARPE	(1<<7)
#define OPM		(1<<3)
#define URS		(1<<2)
#define UDIS	(1<<1)
#define	CEN		(1<<0)




volatile char flag;
volatile int ms;

#define SIMULATOR

void timer5_interrupt( void )
{  /* 1 ms period */
unsigned short status;
	status = *TIM5_SR;
	//flag = (char) status;
	flag = 1;
	*GPIO_D_ODRLOW = 1;

	*TIM5_SR = ~status;
		*TIM5_CR1 &= ~CEN;


}



void timer5_init( )
{
	/* System core clock: 168MHz
	 * TIM6 and TIM7 clocks: 84 MHz
	 * APB2 Clock: 84 MHz
	 * APB1 Clock: 42 MHz */
	
	/* For Now, move to debugger MD407 and simulator init */ 
	*RCC_APB1ENR	|= (1<<3); 	/* Enable TIMER 5 */	
	*RCC_APB1RSTR	|= (1<<3); 	/* Reset TIMER 5 */	
	*RCC_APB1RSTR	&= ~(1<<3); 	

	*TIM5_CR1 &= ~CEN;
	 	 
	*TIM5_IRQVEC = timer5_interrupt;
	*NVIC_TIM5_ISER |= NVIC_TIM5_IRQ_BPOS;	/* Enable this interrupt */ 
	 
	 /* freq: PSC is # of microsecs-1 */
	 #if 0
#ifdef SIMULATOR
	*TIM5_PSC= 999; 	/* 1 ms period */
	*TIM5_ARR = 83;
#else
	*TIM5_PSC= 999; 
	*TIM5_ARR = 83;
#endif
#endif

	//*TIM5_DIER |= CC1IE;	/* Test Output compare 1 */
	//*TIM5_CR1 |= (CEN | OPM);	/* One pulse mode */
	//*TIM5_CR1 |= CEN;

}



void timer5_deinit( )
{
	 *TIM5_CR1 &= ~CEN;
}


void gpio_init( void )
{ /* for test */
	*GPIO_D_MODER = 0x00005555;		
	*GPIO_D_PUPDR = 0x00000000;		/* Input, pull down */
    *GPIO_D_OTYPER= 0x00000000;	    /* outputs are push/pull */
	*GPIO_D_ODRLOW = 0;
}




void main(void)
{
	flag = 0;
	ms = 0;
	gpio_init();
		timer5_init();
		srand( 100 );
	while( 1 )
	{
		*GPIO_D_ODRLOW = 0;
		
	 *TIM5_CR1 &= ~CEN;
		
	*TIM5_PSC= 0; 	/* 1 ms period */
	*TIM5_ARR = 82999;
	*TIM5_DIER |= CC1IE;	/* Test Output compare 1 */
	*TIM5_CR1 |= CEN;
	
	unsigned int r = rand();

		while(flag == 0);
		
		
#ifdef TEST_EGR
		*GPIO_D_ODRLOW = flag;
		*TIM5_EGR |= UG;   /* Ok */
		*GPIO_D_ODRLOW = flag;
		*GPIO_D_ODRLOW = flag;
		*TIM5_EGR |= CC1G;   /* Ok */
		*GPIO_D_ODRLOW = flag;
		*GPIO_D_ODRLOW = flag;
		*TIM5_EGR |= CC2G;   /* Ok */
		*GPIO_D_ODRLOW = flag;
		*GPIO_D_ODRLOW = flag;
		*TIM5_EGR |= CC3G;   /* Ok */
		*GPIO_D_ODRLOW = flag;
		*GPIO_D_ODRLOW = flag;

		*TIM5_EGR |= CC4G;   /* Ok */
		*GPIO_D_ODRLOW = flag;
		*GPIO_D_ODRLOW = flag;

		*TIM5_EGR |= TG;   /* Ok */
		*GPIO_D_ODRLOW = flag;
		*GPIO_D_ODRLOW = flag;
#endif
	}
}
