/*
 * 	startup.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

typedef unsigned int uint32_t;
typedef unsigned short uint16_t;
typedef struct
{
  volatile uint32_t sr;     /* status register                          0x00 */
  volatile uint32_t cr1;    /* ontrol register 1                        0x04 */      
  volatile uint32_t cr2;    /* control register 2                       0x08 */
  volatile uint32_t smpr1;  /* sample time register 1                   0x0C */
  volatile uint32_t smpr2;  /* sample time register 2                   0x10 */
  volatile uint32_t jofr1;  /* injected channel data offset register 1  0x14 */
  volatile uint32_t jofr2;  /* injected channel data offset register 2  0x18 */
  volatile uint32_t jofr3;  /* injected channel data offset register 3  0x1C */
  volatile uint32_t jofr4;  /* injected channel data offset register 4  0x20 */
  volatile uint32_t htr;    /* watchdog higher threshold register       0x24 */
  volatile uint32_t ltr;    /* watchdog lower threshold register        0x28 */
  volatile uint32_t sqr1;   /* regular sequence register 1              0x2C */
  volatile uint32_t sqr2;   /* regular sequence register 2              0x30 */
  volatile uint32_t sqr3;   /* regular sequence register 3              0x34 */
  volatile uint32_t jsqr;   /* injected sequence register               0x38 */
  volatile uint32_t jdr1;   /* injected data register 1                 0x3C */
  volatile uint32_t jdr2;   /* injected data register 2                 0x40 */
  volatile uint32_t jdr3;   /* injected data register 3                 0x44 */
  volatile uint32_t jdr4;   /* injected data register 4                 0x48 */
  volatile uint32_t dr;     /* regular data register                    0x4C */
} ADC_ARM_DEVICE, *PADC_ARM_DEVICE;

#define ADC1 ((PADC_ARM_DEVICE) 0x40012000)



void init_adc( void )
{
  /* Bestäm GPIO port och pinne, initiera som ANALOG ingång */
  
  /* ADC kanal 0,  Rank 1, Konverteringstid 56 cykler */
  ADC1->smpr2 = 3;   
  ADC1->sqr3 = 0 ; 
}

unsigned short read_adc( void )
{
  ADC1->cr2 |= (uint32_t) (1<<30) ;  /* Starta konvertering */	
  while( (ADC1->sr & (1<<1) ) ==0 ); /* Vänta tills AD omvandling klar */
  return (unsigned short) ADC1->dr;  /* Returnera resultatet */
}

void main(void)
{
	uint16_t samples[1024];	
	init_adc();
	for( int i = 0; i < sizeof(samples); i++ )
	{   /* Samplingsfrekvens, 10 Hz */
		samples[i] = read_adc();
		delay_ms( 100 );
	}
}

