/*
 * 	startup.c
 *  Test program for debugger built in routines
 */
 #include	"md407.h"

 
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

#define	MAGIC_WORD			((unsigned int *) 0x08000200)
#define HAS_MAGIC_WORD		((*MAGIC_WORD & 0xFFFFFF00) == 0xABACAB00 )
#define DBG_SUPPORT_LEVEL	(*MAGIC_WORD & 0xFF)


#define rtsinit	((void (*)(void) ) (0x0800020C+1) ) 
#define restart	((void (*)(void) ) (0x08000204+1) ) 
#define gdbinit	((void (*)(void) ) (0x08000208+1) ) 


#define EXTI7_IRQVEC	((void (**)(void) ) 0x2001C09C ) 

void irq_handler ( void )
{
	if ( EXTI->imr & (1<<7) )
	{	/* This is really Port B pin 7 */
		EXTI->pr  |=  (1<<7);	/* Acknowledge .. */
		/* Toggle ODR bit */
		if( GPIOB->odr & 1 )
		{
			GPIOB->bsrh |= 0x0003;	/* Pins 0 and 1 , clear bits to turn LED on */
			
		}else{
			GPIOB->bsrl |= 0x0003;	/* Pins 0 and 1, set bit to turn LED off */
		}
	}
}

#define	USBDM
int	pushbuttons_and_led( void )
{
	/* check the magic... */
	if( HAS_MAGIC_WORD )
	{
		if( DBG_SUPPORT_LEVEL >= 0 )
		{
#ifdef	USBDM
			SCB->vtor = (unsigned long )0x2001C000;	/* Relocate interrupt vectors base */
#endif
			rtsinit();	/* Call DBG built in */
			*EXTI7_IRQVEC = irq_handler;
			NVIC->iser0 |= (1<<23);	/* Enable this interrupt */  
			return 0;
		}         
	}	
	return -1;
}

void _outchar( unsigned char ch )
{
	USART1->dr = (unsigned short) ch;
 	while (( USART1->sr & 0x80)==0);
}

unsigned char  _inchar( void )
{
	while( (USART1->sr & 0x20)==0);
	return (char) USART1->dr;
}


void main(void)
{
#if 0
	if( pushbuttons_and_led() )
	{
		// Print diagnostics and exit 
	}
	
	while( 1 )
	{
	}
#endif
	gdbinit();

	RCC->apb2enr |= 0x10; 		/* Enable USART 1 clock */
	RCC->ahb1enr |= 1; 			/* Enable port A */
	
	RCC->apb2rstr	|= 0x10; 	/* Reset USART1 */	
	RCC->apb2rstr	&= ~0x10; 	
	RCC->ahb1rstr |= 1; 		/* Reset port A */
	RCC->ahb1rstr &= ~1; 		/* Reset port A */

	/* Connect USART pins to AF */
	GPIOA->afrh |= 0x770;
	/* PA9 - USART1 TX  */
	/* PA10 - USART1 RX */
	GPIOA->moder |= 0x00280000;	/* Pins 9 and 10 are AF */
	GPIOA->pupdr |= 0x00100000;	/* Pin 10 pull up */
	
	/* Now, start the USART */
	USART1->brr = 0x2D9;	/* Set UART baudrate (115 200) */
	USART1->cr1 = 0x200C;	/* Enable USART, TE/RX */

	unsigned char c;
	while(1)
	{
		c = _inchar();
		_outchar ( c );
	}

	
}

