/*
 * 	startup.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

typedef struct gamedisplay
{
	unsigned int ex:1;
	unsigned int :1;
	unsigned int cmd:5;
	unsigned int rot:9;

	unsigned int :0;
	unsigned int blue:8;
	unsigned int green:8;
	unsigned int red:8;
	unsigned int bgint:8;

	unsigned int :0;
	unsigned int xcoord1:10;
	unsigned int :6;
	unsigned int ycoord1:10;
	
	unsigned int :0;
	unsigned int xcoord2:10;
	unsigned int :6;
	unsigned int ycoord2:10;
	
	unsigned int :0;
	unsigned int xcoord3:10;
	unsigned int :6;
	unsigned int ycoord3:10;
} GAMEDISPLAY;

#define	R	(( GAMEDISPLAY *) 0xF0000000)


void setbgnd( int intensity )
{
	R->bgint = intensity;	
	R->cmd = 0;
	R->ex = 0;
	R->ex = 1;
}

void rect(int x,int y, int xwidth, int ywidth, int draw , int filled )
{
	R->xcoord1 = x;
	R->ycoord1 = y;
	R->xcoord2 = xwidth+x;
	R->ycoord2 = ywidth+y;
	if( filled )
	{
		if( draw )
			R->cmd = 11;
		else
			R->cmd = 12;
		
	}else{
		if( draw )
			R->cmd = 9;
		else
			R->cmd = 10;
	}
	R->ex = 0;
	R->ex = 1;
}

void ellipse(int x,int y, int xwidth, int ywidth, int draw , int filled )
{
	R->xcoord1 = x;
	R->ycoord1 = y;
	R->xcoord2 = xwidth;
	R->ycoord2 = ywidth;
	if( filled )
	{
		if( draw )
			R->cmd = 12;
		else
			R->cmd = 13;
		
	}else{
		if( draw )
			R->cmd = 10;
		else
			R->cmd = 11;
	}
	R->ex = 0;
	R->ex = 1;
}



void setcolour( int r, int g, int b )
{
	R->red = r;
	R->green = g;
	R->blue = b;
}

void	pixel( int x, int y, int draw )
{
	R->xcoord1 = x;
	R->ycoord1 = y;
	if( draw )
		R->cmd = 5;
	else
		R->cmd = 6;
	R->ex = 0;
	R->ex = 1;
}

void	line( int x1, int y1, int x2, int y2,int draw )
{
	R->xcoord1 = x1;
	R->ycoord1 = y1;
	R->xcoord2 = x2;
	R->ycoord2 = y2;
	if( draw )
		R->cmd = 7;
	else
		R->cmd = 8;
	R->ex = 0;
	R->ex = 1;
}

#define	DRAW_PIXEL(a,b) 				pixel(a,b,1)
#define	CLEAR_PIXELa,b)					pixel(a,b,0)

#define	DRAW_LINE(a,b,c,d) 				line(a,b,c,d,1)
#define	CLEAR_LINE(a,b,c,d)				line(a,b,c,d,0)

#define	DRAW_RECT(a,b,c,d) 				rect(a,b,c,d,1,0)
#define	CLEAR_RECT(a,b,c,d)				rect(a,b,c,d,0,0)
#define	DRAW_FILLED_RECT(a,b,c,d) 		rect(a,b,c,d,1,1)
#define	CLEAR_FILLED_RECT(a,b,c,d)		rect(a,b,c,d,0,1)

#define	DRAW_ELLIPSE(a,b,c,d) 			ellipse(a,b,c,d,1,0)
#define	CLEAR_ELLIPSE(a,b,c,d)			ellipse(a,b,c,d,0,0)
#define	DRAW_FILLED_ELLIPSE(a,b,c,d) 	ellipse(a,b,c,d,1,1)
#define	CLEAR_FILLED_ELLIPSE(a,b,c,d)	ellipse(a,b,c,d,0,1)

/* SysTick */
#define		STK_CTRL 	((volatile unsigned int *)(0xE000E010))  
#define		STK_LOAD 	((volatile unsigned int *)(0xE000E014))  
#define		STK_VAL 	((volatile unsigned int *)(0xE000E018))  

#define DELAY_VAL	168000/4-1
void delay( void )
{
	/* SystemCoreClock = 168000000 */
	*STK_CTRL = 0;
	*STK_LOAD = DELAY_VAL;
	*STK_VAL = 0;
	*STK_CTRL = 5;
	while( (*STK_CTRL & 0x10000 )== 0 );
	*STK_CTRL = 0;
}

void main(void)
{
    
	int	sx,xy;
	setbgnd( 0x0 );
	while(1)
	{
		setcolour( 128, 0, 0 );
		
		for( int i = 10; i<100;i++)
		{
			DRAW_FILLED_ELLIPSE(80,72,i,i); 
			delay();	
			CLEAR_FILLED_ELLIPSE(80,72,i,i);
		}
		for( int i = 100; i>10;i--)
		{
			DRAW_FILLED_ELLIPSE(80,72,i,i); 
			delay();	
			CLEAR_FILLED_ELLIPSE(80,72,i,i);
		}
	}
}

