/*
 * 	startup.c
 *
 */
__attribute__((naked)) __attribute__((section (".start_section")) )
void startup ( void )
{
__asm__ volatile(" LDR R0,=0x2001C000\n");		/* set stack */
__asm__ volatile(" MOV SP,R0\n");
__asm__ volatile(" BL main\n");					/* call main */
__asm__ volatile(".L1: B .L1\n");				/* never return */
}

typedef struct gamedisplay
{
	unsigned int ex:1;
	unsigned int abt:1;
	unsigned int cmd:5;
	unsigned int :8;
	unsigned int busy:1;

	unsigned int :0;
	unsigned int blue:8;
	unsigned int green:8;
	unsigned int red:8;
	unsigned int bgint:8;

	unsigned int :0;
	unsigned int xcoord1:10;
	unsigned int :6;
	unsigned int ycoord1:10;
	
	unsigned int :0;
	unsigned int xcoord2:10;
	unsigned int :6;
	unsigned int ycoord2:10;
	
	unsigned int :0;
	unsigned int xcoord3:10;
	unsigned int :6;
	unsigned int ycoord3:10;

	unsigned int :0;
	unsigned int xcoord4:10;
	unsigned int :6;
	unsigned int ycoord4:10;	
} GAMEDISPLAY;

#define	R	(( GAMEDISPLAY *) 0xF0000000)


void setbgnd( int intensity )
{
	R->bgint = intensity;	
	R->cmd = 0;
	R->ex = 0;
	R->ex = 1;
}

void rect(int x,int y, int xwidth, int ywidth, int draw , int filled )
{
	R->xcoord1 = x;
	R->ycoord1 = y;
	R->xcoord2 = xwidth+x;
	R->ycoord2 = ywidth+y;
	if( filled )
	{
		if( draw )
			R->cmd = 11;
		else
			R->cmd = 12;
		
	}else{
		if( draw )
			R->cmd = 9;
		else
			R->cmd = 10;
	}
	R->ex = 0;
	R->ex = 1;
}

void ellipse(int x,int y, int xwidth, int ywidth, int draw , int filled )
{
	R->xcoord1 = x;
	R->ycoord1 = y;
	R->xcoord2 = xwidth;
	R->ycoord2 = ywidth;
	if( filled )
	{
		if( draw )
			R->cmd = 15;
		else
			R->cmd = 16;
		
	}else{
		if( draw )
			R->cmd = 13;
		else
			R->cmd = 14;
	}
	R->ex = 0;
	R->ex = 1;
}



void setcolour( int r, int g, int b )
{
	R->red = r;
	R->green = g;
	R->blue = b;
}

void	pixel( int x, int y, int draw )
{
	R->xcoord1 = x;
	R->ycoord1 = y;
	if( draw )
		R->cmd = 5;
	else
		R->cmd = 6;
	R->ex = 0;
	R->ex = 1;
}

void	line( int x1, int y1, int x2, int y2,int draw )
{
	R->xcoord1 = x1;
	R->ycoord1 = y1;
	R->xcoord2 = x2;
	R->ycoord2 = y2;
	if( draw )
		R->cmd = 7;
	else
		R->cmd = 8;
	R->ex = 0;
	R->ex = 1;
}

#define	DRAW_PIXEL(a,b) 				pixel(a,b,1)
#define	CLEAR_PIXELa,b)					pixel(a,b,0)

#define	DRAW_LINE(a,b,c,d) 				line(a,b,c,d,1)
#define	CLEAR_LINE(a,b,c,d)				line(a,b,c,d,0)

#define	DRAW_RECT(a,b,c,d) 				rect(a,b,c,d,1,0)
#define	CLEAR_RECT(a,b,c,d)				rect(a,b,c,d,0,0)
#define	DRAW_FILLED_RECT(a,b,c,d) 		rect(a,b,c,d,1,1)
#define	CLEAR_FILLED_RECT(a,b,c,d)		rect(a,b,c,d,0,1)

#define	DRAW_ELLIPSE(a,b,c,d) 			ellipse(a,b,c,d,1,0)
#define	CLEAR_ELLIPSE(a,b,c,d)			ellipse(a,b,c,d,0,0)
#define	DRAW_FILLED_ELLIPSE(a,b,c,d) 	ellipse(a,b,c,d,1,1)
#define	CLEAR_FILLED_ELLIPSE(a,b,c,d)	ellipse(a,b,c,d,0,1)


typedef struct tPoint
{
	unsigned char x;
	unsigned char y;
}POINT;

#define MAX_POINTS 30



/* SysTick */
#define		STK_CTRL 	((volatile unsigned int *)(0xE000E010))  
#define		STK_LOAD 	((volatile unsigned int *)(0xE000E014))  
#define		STK_VAL 	((volatile unsigned int *)(0xE000E018))  

#define DELAY_VAL	168000/4-1
void delay( void )
{
	/* SystemCoreClock = 168000000 */
	*STK_CTRL = 0;
	*STK_LOAD = DELAY_VAL;
	*STK_VAL = 0;
	*STK_CTRL = 5;
	while( (*STK_CTRL & 0x10000 )== 0 );
	*STK_CTRL = 0;
}

#define MAX_POINTS 30

typedef struct tGeometri
{
	int	numpoints;
	int	sizex;
	int	sizey;
	POINT	px[ MAX_POINTS ];
} GEOMETRY, *PGEOMETRY;
	

GEOMETRY ball_g =
{
	12,		// numpoints
	4,4,		// sizex,sizey
	{
		{0,1},		// px[]
		{0,2},
		{1,0},
		{1,1},
		{1,2},
		{1,3},
		{2,0},
		{2,1},
		{2,2},
		{2,3},
		{3,1},
		{3,2}
	}
};

GEOMETRY paddle_g =
{
	27,		// numpoints
	3,6,		// sizex,sizey
	{
		{0,0},		// px[]
		{0,1},		
		{0,2},
		{0,3},
		{0,4},
		{0,5},
		{0,6},
		{0,7},
		{0,8},
		{1,0},		
		{1,8},		
		{2,0},		
		{2,3},		
		{2,4},		
		{2,5},		
		{2,8},		
		{3,0},		
		{3,8},		
		{4,0},		
		{4,1},		
		{4,2},
		{4,3},
		{4,4},
		{4,5},
		{4,6},
		{4,7},
		{4,8},

	}
};

enum object_type 
{
    PIXEL,
    LINE,
    RECTANGLE,
    ELLIPSE
};

typedef struct tObj{
    int type;   /* pixel, line rect or ellipse */
	PGEOMETRY geo;
	int	dirx,diry;
	unsigned int	posx,posy;
	void (* draw ) (struct tObj *);
	void (* clear ) (struct tObj *);
	void (* move ) (struct tObj *);
	void (* set_speed ) (struct tObj *, int, int);
} OBJECT, *POBJECT;





static void pixel_object(POBJECT o, int set)
{
	int	i;
	for( i = 0; i < o->geo->numpoints; i++ )
	{
		pixel ( o->geo->px[i].x + o->posx, o->geo->px[i].y + o->posy, set );
	}
}

void draw_object(POBJECT o)
{
	pixel_object(o, 1);
}


void clear_object(POBJECT o)
{
	pixel_object(o, 0);
}

void	set_object_speed(POBJECT o, int speedx, int speedy)
{ 
	o->dirx = speedx;
	o->diry = speedy;	
}




void	move_ball_object(POBJECT o )
{
	/* move object in direction */
	int cx, cy;
	
	o->clear(o);	/* rubout current object */

	cx = o->posx + o->dirx;
	cy = o->posy + o->diry;

	/* should object bounce?  */
	if( cy + o->geo->sizey > 64) 
	{
		o->diry = - o->diry;
		cy = 64 - o->geo->sizey;
	} 
	else if( cy<1 )
	{
		o->diry = - o->diry;
		cy = 1;
	}		
	/* save new position */
	o->posx =  cx;
	o->posy =  cy;
	o->draw(o);
}




void	move_paddle_object(POBJECT o )
{
	/* move object in direction */
	int cx, cy;
	
	o->clear(o);	/* rubout current object */

	cy = o->posy + o->diry;

	/* should object stop?  */
	if( cy + o->geo->sizey > 64) 
	{
		cy = 64 - o->geo->sizey;
	} 
	else if( cy<1 )
	{
		cy = 1;
	}		
	/* save new position */
	o->posy =  cy;
	o->draw(o);
}

int objects_contact( POBJECT o1, POBJECT o2 )
{
	/* if object 1 in contact with object 2 return 1, else 0 */
	int o1xlow, o1xhigh, o1ylow, o1yhigh;
	int o2xlow, o2xhigh, o2ylow, o2yhigh;
	
	o1xlow = o1->posx;
	o1xhigh = o1xlow+o1->geo->sizex;
	o1ylow = o1->posy;
	o1yhigh = o1ylow+o1->geo->sizey;
	
	o2xlow = o2->posx;
	o2xhigh = o2xlow+o2->geo->sizex;
	o2ylow = o2->posy;
	o2yhigh = o2ylow+o2->geo->sizey;
	
	if( o1xlow <= o2xlow )
	{
		if( o2xlow > o1xhigh ) return 0;
		if( o1ylow <= o2ylow ){
			if( o2ylow > o1yhigh ) return 0;			
		}else{
			if( o2yhigh < o1ylow ) return 0;						
		}
	}else{
		if( o1xlow > o2xhigh ) return 0;
		if( o1ylow <= o2ylow ){
			if( o2ylow > o1yhigh ) return 0;			
		}else{
			if( o2yhigh < o1ylow ) return 0;						
		}		
	}
	return 1;
}


int  pixel_compare(POBJECT o1, POBJECT o2)
{
	int offset1x = o1->posx;
	int offset1y = o1->posy;
	int offset2x = o2->posx;
	int offset2y = o2->posy;
	for( int i = 0; i < o1->geo->numpoints; i++ )
	{
		for( int j = 0; j < o2->geo->numpoints; j++ )
			if( ( offset1x+o1->geo->px[i].x == offset2x+o2->geo->px[j].x ) &&
				( offset1y+o1->geo->px[i].y == offset2y+o2->geo->px[j].y ) )
				return 1;
	}
	return 0;
}



void init_app( void )
{
#ifdef USBDM	
	/* starta klockor port D och E */
	* ( (unsigned long *) 0x40023830) = 0x18;
	__asm( 	" BL =0x08000209\n");
#endif	
	/*	PORT D
 	b15-b12 used for output to rows
	b11-b8  used for input from columns
	b7-b0 	used for output to 7-seg display
	*/
	*GPIO_D_MODER = 		0x55005555;		
	*GPIO_D_PUPDR = 		0x00AA0000;		/* Input, pull down */
    *GPIO_D_OTYPER     = 0x00000000;	    /* outputs are push/pull */
}


/* Deklarera och instansiera ett objekt i form av en liten boll */
static OBJECT	ball_object =
{
	&ball_g,			// geometri för en boll
	2,1,				// initiala riktningskoordinater
	1,1,				// initial startposition
	draw_object,
	clear_object,
	move_ball_object,	
	set_object_speed
};

/* Deklarera och instansiera ett objekt i form av en liten otrevlig varelse */
static OBJECT	paddle1_object =
{
	&paddle_g,			// geometri för racket
	0,0,				// initiala riktningskoordinater
	0,30,				// initial startposition
	draw_object,
	clear_object,
	move_paddle_object,	
	set_object_speed
};

static OBJECT	paddle2_object =
{
	&paddle_g,			// geometri för racket
	0,0,				// initiala riktningskoordinater
	123,30,				// initial startposition
	draw_object,
	clear_object,
	move_paddle_object,	
	set_object_speed
};

unsigned short keyb_alt_ctrl(void) 
{
	int row;
	unsigned short pad;
	*GPIO_D_ODRHIGH = 0x80;
	pad = (*GPIO_D_IDRHIGH & 0xF);
	*GPIO_D_ODRHIGH = 0x40;
	pad |= ((*GPIO_D_IDRHIGH & 0xF)<<4);
	*GPIO_D_ODRHIGH = 0x20;
	pad |= ((*GPIO_D_IDRHIGH & 0xF)<<8);
	*GPIO_D_ODRHIGH = 0x10;
	pad |= ((*GPIO_D_IDRHIGH & 0xF)<<12);
	*GPIO_D_ODRHIGH = 0;
	return pad;
}

/* Bitmasker för tangenter */
#define LEFT_UP 	0x1000
#define LEFT_DOWN 	1

#define RIGHT_UP 	0x8000
#define RIGHT_DOWN 	8

/* ---------------------------------------------------- */




int main()
{
	unsigned short s;
	POBJECT ball = &ball_object;
	POBJECT paddle1 = &paddle1_object;
	POBJECT paddle2 = &paddle2_object;
	init_app();	
	graphic_initalize();
	graphic_clearScreen();
	ball->set_speed( ball, 4, 1);
	
	while( 1 )
	{
		ball->move( ball );
		paddle1->move( paddle1 );
		paddle2->move( paddle2 );
		s = keyb_alt_ctrl();
		
		if( ( s & (LEFT_UP | LEFT_DOWN)  )== (LEFT_UP | LEFT_DOWN) )
			paddle1->set_speed( paddle1, 0, 0); 
		else if (s & LEFT_UP )  
			paddle1->set_speed( paddle1, 0, -4); 
		else if (s & LEFT_DOWN )  
			paddle1->set_speed( paddle1, 0, 4); 
		else
			paddle1->set_speed( paddle1, 0, 0); 
				
		if( ( s & (RIGHT_UP | RIGHT_DOWN)  )== ( RIGHT_UP | RIGHT_DOWN)  )
			paddle2->set_speed( paddle2, 0, 0); 
		else if (s & RIGHT_UP )  
			paddle2->set_speed( paddle2, 0, -4); 
		else if (s & RIGHT_DOWN )  
			paddle2->set_speed( paddle2, 0, 4); 
		else
			paddle2->set_speed( paddle2, 0, 0); 
		
//		if( objects_contact( ball, paddle1 ))
		if( pixel_compare( ball, paddle1 ))
		{	/* bounce */
			ball->clear(ball);	
	  		ball->dirx = - ball->dirx;
			ball->draw(ball);
		}else if( ball->posx < (1 + ball->geo->sizex) )
		{
			/* player 2 won */
			break;
		}

//		if( objects_contact( ball, paddle2 ))
		if( pixel_compare( ball, paddle2 ))
		{	/* bounce */
			ball->clear(ball);	
			ball->dirx = - ball->dirx;
			ball->draw(ball);
		}else if( ball->posx > (128 - ball->geo->sizex) )
		{
			break;
			/* player 1 won */
		}
	  
		delay_milli(20);
	}
}
